	function getPage (event, page) {
		return $support.touch ? event.changedTouches[0][page] : event[page];
	}
	var zyBounce = function(selector){
		var self = this;
		self._click=false;
		if(typeof selector == 'object')
			self.element = selector;
		else if(typeof selector == 'string')
			self.element = document.getElementById(selector);
		self.attribute=self.element.getAttribute("onclick");
		self.element.removeAttribute("onclick");
		self.element.addEventListener($E.start, self, false);
		self.element.addEventListener($E.end, self, false);
		if($E.cancel!="")
		{
			self.element.addEventListener($E.cancel, self, false);
			document.addEventListener($E.cancel, self, false);
		}
		document.addEventListener($E.end, self, false);
		return self;
	}
	
	
	zyBounce.prototype = {
		handleEvent: function(event) {
			var self = this;
			switch (event.type) {
				case $E.start:
					self._touchStart(event);
					break;
				case $E.move:
					self._touchMove(event);
					break;
				case $E.end:
				case $E.cancel:
					self._touchEnd(event);
					break;
			}
		},
        _touchStart: function(event) {
			if (!self.touchTime) {
                self.touchTime=setTimeout(function(){
                    uexWindow.setBounce('0');
                }, 500);
			}
        },
        _touchMove: function(event) {
        	
            
        },
        _touchEnd: function(event) {
        	uexWindow.setBounce('1');
			if (self.touchTime) {
				clearTimeout(self.touchTime);
				self.touchTime=null;
			}        
        }
	}
	
	
	var zyClick = function(selector,clickFun,css){
		var self = this;
		self._clickFun = clickFun || null;
		self._click=false;
		self.css = css;
		if(typeof selector == 'object')
			self.element = selector;
		else if(typeof selector == 'string')
			self.element = document.getElementById(selector);
		self.attribute=self.element.getAttribute("onclick");
		self.element.removeAttribute("onclick");
		self.element.addEventListener($E.start, self, false);
		self.element.addEventListener($E.move, self, false);
		self.element.addEventListener($E.end, self, false);
		if($E.cancel!="")
		{
			self.element.addEventListener($E.cancel, self, false);
			document.addEventListener($E.cancel, self, false);
		}
		document.addEventListener($E.end, self, false);
		
		return self;
	}

	zyClick.prototype = {
		handleEvent: function(event) {
			var self = this;
			switch (event.type) {
				case $E.start:
					self._touchStart(event);
					break;
				case $E.move:
					self._touchMove(event);
					break;
				case $E.end:
				case $E.cancel:
					self._touchEnd(event);
					break;
			}
		},
        _touchStart: function(event) {
            var self = this;
            self.start = true;
            self._click=true;
            self.startPageX = getPage(event, 'pageX');
            self.startPageY = getPage(event, 'pageY');
            self.startTime = event.timeStamp;
			if(self._clickFun){	//长按事件
	            self.funTime=setTimeout(function(){
					self._clickFun(self.element);
					if(self._click) self._click=false;
				}, 500);
			}
            if (self.css && !self.touchTime) {
                self.touchTime=setTimeout(function(){
                    if (self._click && self.element.className.indexOf(self.css)<0) 
                        self.element.className += (" " + self.css);
                }, 50);
			}
        },
        _touchMove: function(event) {
        	
            var self = this;
			if(!self.start)
				return;
			
			if ( self.funTime) {
				clearTimeout(self.funTime);
				self.funTime=null;
			}
			
            var pageX = getPage(event, 'pageX'),
                pageY = getPage(event, 'pageY'),
                deltaX = pageX - self.startPageX,
                deltaY = pageY - self.startPageY;

           if((Math.abs(deltaX)>5 || Math.abs(deltaY)>5))
           {
				if (self._click) {
					clearTimeout(self.touchTime);
					self.touchTime = null;
					self._click = false;
					if (self.css) 
						self.element.className = self.element.className.replace(" " + self.css, "");
				}
		   }		
		   else{

		   }
        },
        _touchEnd: function(event) {
        	
            var self = this;
            if(self.start == true)
            {
				if (self.touchTime) {
					clearTimeout(self.touchTime);
					self.touchTime=null;
				}
				if ( self.funTime) {
					clearTimeout(self.funTime);
					self.funTime=null;
				}
            	self.start = false;
            	if(self.css)
            		self.element.className=self.element.className.replace(" "+self.css,"");
            	if(self._click)
            	{
            		self._click=false;
            		if(event.timeStamp - self.startTime>1000)
            			return;
					if(event.type==$E.cancel)
						return;
            		//if(self._clickFun)
	           			//self._clickFun(self.element);
					if(self.attribute)
						eval(self.attribute);
            	}
            }
        },
        destroy: function() {
            var self = this;

            self.element.removeEventListener($E.start, self);
            self.element.removeEventListener($E.move, self);
            self.element.removeEventListener($E.end, self);
            self.element.removeEventListener($E.cancel, self);
            document.removeEventListener($E.end, self);
            document.removeEventListener($E.cancel, self);
        }
	}

function hrefs(url){
	if(event){
		if(checkActive(event.currentTarget)) return;
	}
	var json=urlParse(url);
	if(json.types=='not') return;
	if(!json.attr || int(json.attr)==0) return;
	if(json.types=='vote'){
		setStorJson('params',{
			id : json.attr
		});	
		
		openwin('vote_'+json.attr,'wgtroot://vote/main.html','2');
	}else if(json.types=='job_index'){
		setStorJson('params',{
			types : 'job/index',
			title : '人才招聘'
		});
		openwin('job_index','wgtroot://head.html','2');
	}else if(json.types=='vip_index'){
		openwin('vip_main','wgtroot://vip/main.html','2');
	}else if(json.types=='vip'){
		setStorJson('params',{
			types : 'vip/item',
			id : json.attr,
			title : 'VIP专享详情'
		});	
		openwin('shop_vip_'+json.attr,'wgtroot://head.html','2');
	}else if(json.types=='deal'){
		setStorJson('params',{
			types : 'deal/item',
			id : json.attr,
			title : '商品详情',
			button_class:'share'
		});	
		openwin('shop_deal_'+json.attr,'wgtroot://head.html','2');
	}else if(json.types=='deal_index'){
		active=0;
		menu('deal/index');
	}else if(json.types == 'deal_arrondi'){
		setStorJson('params',{
			title:localStorage['arrondi_name'],
			types:'deal/index',
			target:'arrondi',
			button_class:'search'
		});	
		openwin('deal/index','wgtroot://head.html','2');
	}else if(json.types=='news'){
		active=0;
		news_jump('news',json.attr);
	}else if(json.types=='news_photos' || json.types=='news_special'){
		json.types=(json.types=='news_photos')?'photos':'special';
		active=0;
		news_jump(json.types,json.attr);
	}else if(json.types=='shop'){
		setStorJson('params',{
			id:json.attr
		});	
		openwin('shop/item_'+json.attr,'wgtroot://shop/item.html','2');
	}else if(json.types=='web'){
		loadLink(json.attr);
	}else if(json.types=='url'){
		var url=json.attr;
		if (url.indexOf('http://') != 0 && url.indexOf('https://') != 0) {
			url='http://'+url
		}
		params={
			title:json.title || '链接',
			url:url
		}
		setStorJson('params',params);
		openwin('url','wgtroot://url.html','2');
	}else{
			uexWindow.cbConfirm = function(opId,dataType,data){
				if(data==0){
					uescript('root',"Upgrade()");
				}					
			}
			uexWindow.confirm('提示','升级至最新版本才能使用本服务内容，是否马上更新？',['是','放弃']);
		 	return;
	}
}

function links(types,title,json){
	if(event){
		if(checkActive(event.currentTarget,1)) return;
	}
	var params={
		types:types,
		title:title
	};
	if(json){
		for(i in json){
			params[i]=json[i];
		}
	}
	setStorJson('params',params);
	openwin(types,'wgtroot://head.html','2');
}

function news_jump(types,id){
	if(event){
		if(checkActive(event.currentTarget)) return;
	}
	var params={
			id:id
		},
		url='wgtroot://news/head.html';
	if(types=='news' || types=='video'){
		params.types='item';
	}else if(types=='special'){	//可去掉这一判断
		params.types='special';
	}
	if(types=='photos'){
		params.types='photos';
		url='wgtroot://news/photos.html';
	}
	types='news_'+params.types+'_'+id;
	setStorJson('params',params);
	openwin(types,url,'2');
}

function jumpSearch(types,title){
	if(event){
		if(checkActive(event.currentTarget,1)) return;
	}
	var params={
			target : 'search',
			key_name : title+'关键词',
			types : types,
			title : title+'搜索'
		};
	setStorJson('params', params);
	openwin(types+'search','wgtroot://head.html','5');
}