/*
 *  desc Based on the appcan 4.0 integrated package
 *  author by TMJ 2017-07-06 11:06:45
 *  version: V4.0.0
 *  base on common.js appcan4.js
 */
/*  环信聊天模块：单聊、群聊、实时语音、客服
 *  支持华为推送
 *  Tips:1、实例唯一，异步调用;
 *       2、所有的回调都会传到"root页面"
 *       3、E1-E8 初始化-注册-登录
 *       4、E9 启动监听事件
 *       5、E10-E39 消息、加好友、好友列表、添加/移除黑名单
 *       6、E40-E59 群
 *       7、E60-E63 拨打语音电话、接听、重新通话、挂断电话
 *       7、E64-E66 Apns
 */
var messageId_last = "";
var EB = {
    msgId:"",
    isStart:false,
    badNum:1,
    init:function(){//E1 初始化环信
        var apnsCertName = "tongyeyunpush";
        var param = {
            appKey:config.easemobAppKey,//区别app的标识   
            apnsCertName:apnsCertName,//iOS中推送证书名称(仅iOS)
            isAutoLoginEnabled:1,//可选参数 是否开启自动登录功能 1-开启 2-关闭
            isAutoAcceptGroupInvitation:1,//可选参数 是否开启用户自动同意群邀请, 1-开启 2-关闭 默认为开启(此参数为3.0.22后新加入)
            miPushAppId:"2882303761517473755",//String类型 可选 小米推送的appId
            miPushAppKey:"5631747327755",//String类型 可选 小米推送的appKey
            huaweiPushAppId:"10535012"//String类型 可选 华为推送的appId//仅支持android
        };
        //apnsCertName不传时,无法使用环信的APNs推送功能
        //自动登录功能Android SDK 默认开启,iOS SDK默认关闭.
        var _this = this;
        _this.initListen();//启动所有环信监听事件
        try{
            uexEasemob.initEasemob(JSON.stringify(param),function(data){
                _this.badNum = 1;
                _this.isStart = true;
                _this.login();
            })
        }catch(e){}
        var userAuthInfo = TM.getStorJson("userAuthInfo");
        if( userAuthInfo && userAuthInfo[0]){
            _this.setNotifyBySoundAndVibrateN();//消息提醒配置
        }else{
            _this.setNotifyBySoundAndVibrate();//消息提醒配置
        }
    },
    registerCallback:function(){//E2 注册回调
        //alert('registerCallback：'+data)
        uexEasemob.registerCallback();
    },
    unRegisterCallback:function(){//E3 取消该页面的监听
        uexEasemob.unRegisterCallback();
    },
    login:function(name,pwd){//E4 登录
        //if(!TM.getStorJson("userInfo"))return;
        //alert("this.isStart:"+this.isStart)
        var _this = this;
        if(TMS.ios){
            try{
                _this.init();
            }catch(e){}
        }else{
            if(!this.isStart){
                this.badNum += 1;
                if(this.badNum < 10){
                    try{
                        _this.init();
                    }catch(e){}
                }
                return;
            }
        }
        var userInfo = TM.getStorJson("userInfoE");
        var param = {
            username: userInfo.user.username,//用户名   userInfo.user.username  "mengyuanyuan"
            password: userInfo.user.username //密码  userInfo.user.username  "123456"
        };
        uexEasemob.login(JSON.stringify(param),function(data){
            //alert('login：'+JSON.stringify(data))
            try{
                _this.getRecentChatters();//刷新消息列表
            }catch(e){}
            //TMA.toasting( data.result +"--"+ data.msg);
            if( data.result == 1 ){
                _this.registerRemoteNotification();//注册Apns推送
                _this.getRecentChatters();//获取最近聊天对象信息
            }else if( data.result == 2 ){
                _this.registerUser();//注册用户
            }
        })
    },
    logout:function(){//E5 登出
        var _this = this;
        try{
            uexEasemob.logout(function(data){
                //alert('logout：'+JSON.stringify(data))
                //TM.logs('logout:'+data);
            })
        }catch(e){}
    },
    registerUser:function(name,pwd){//E6 注册
        var userInfo = TM.getStorJson("userInfoE");
        var param = {
            username:userInfo.user.username,//用户名
            password:userInfo.user.username//密码
        };
        var _this = this;
        uexEasemob.registerUser(JSON.stringify(param),function(data){
            //alert('registerUser'+data);
            //TM.logs('registerUser:'+data);
            if( data.result == 1 ){
                _this.login();
            }
        })
    },
    updateCurrentUserNickname:function(name){//E7 更新当前用户的昵称
        //注:此方法主要为了在苹果推送时能够推送昵称(nickname)而不是userid,
        //一般可以在登陆成功后从自己服务器获取到个人信息,然后拿到nick更新到环信服务器.
        //并且,在个人信息中如果更改个人的昵称,也要把环信服务器更新下nickname 防止显示差异.
        var param = {    
            nickname:name,
        };
        uexEasemob.updateCurrentUserNickname(JSON.stringify(param));
    },
    getLoginInfo:function(){//E8 获取当前登陆信息(仅iOS可用)
        //userInfo://当前登陆用户信息
        //isLoggedIn://当前是否已有登录用户  1-是 2-否
        //isConnected://是否连上聊天服务器   1-是 2-否
        //isAutoLoginEnabled://是否自动登录  1-是 2-否
        try{
            uexEasemob.getLoginInfo(function(data){
                //TM.logs('getLoginInfo:'+data);
            })
        }catch(e){}
    },
    sendText:function(id,type,content,ext,extObj){//E10 发送文本消息及表情
        var param = {
            username:id,//单聊时聊天人的userid或者群聊时groupid
            chatType:type,//0-单聊,1-群聊
            content:content//,文本内容
            //ext: ext || {},//扩展属性(可选参数,String)
            //extObj: extObj || {}//扩展参数(iOS 3.0.22, Android 3.0.23新增可选参数,JSONString extObj存在时ext无效).用于环信移动客服功能,详情见[环信移动客服文档]
        };
        //TM.logs(JSON.stringify(param));
        try{
            uexEasemob.sendText(JSON.stringify(param));
        }catch(e){}
    },
    sendFile:function(id,type,path,displayName,ext,extObj){//E11 发送文件
        var param = {
            username:id,//单聊时聊天人的userid或者群聊时groupid
            chatType:type,//0-单聊,1-群聊
            filePath:path,//文件路径
            displayName:displayName || ""//,对方接收时显示的文件名(仅iOS需要)
            //ext: ext || {},//扩展属性(可选参数,String)
            //extObj: extObj || {}//扩展参数(iOS 3.0.22, Android 3.0.23新增可选参数,JSONString extObj存在时ext无效).用于环信移动客服功能,详情见[环信移动客服文档]
        };
        //TM.logs(JSON.stringify(param));
        uexEasemob.sendFile(JSON.stringify(param));
    },
    sendPicture:function(id,type,filePath,displayName,ext,extObj){//E12 发送图片
        var param = {
            username:id,//单聊时聊天人的userid或者群聊时groupid
            chatType:type,//0-单聊,1-群聊
            filePath:filePath,//文件路径
            displayName:displayName || ""//,对方接收时显示的文件名(仅iOS需要)
            //ext: ext || {},//扩展属性(可选参数,String)
            //extObj: extObj || {}//扩展参数(iOS 3.0.22, Android 3.0.23新增可选参数,JSONString extObj存在时ext无效).用于环信移动客服功能,详情见[环信移动客服文档]
        };
        //TM.logs(JSON.stringify(param));
        var data = {};
        data.from = id;
        if(type == 1)data.to = id;
        data.chatType = type;
        data.messageType = "image";
        data.messageBody = {};
        data.messageTime = new Date().getTime();
        TMA.evalPopScript("index2","content","fillMsg('"+ JSON.stringify(data) +"','',true)");  
        try{
            uexEasemob.sendPicture(JSON.stringify(param));
        }catch(e){}
    },
    sendLocationMsg:function(id,type,address,latitude,longitude,ext,extObj){//E13 发送地理位置信息
        var param = {
            username:id,//单聊时聊天人的userid或者群聊时groupid
            chatType:type,//0-单聊,1-群聊
            locationAddress:address,///地理位置信息
            latitude:latitude,//
            longitude:longitude,
            ext: ext || {},//扩展属性(可选参数,String)
            extObj: extObj || {}//扩展参数(iOS 3.0.22, Android 3.0.23新增可选参数,JSONString extObj存在时ext无效).用于环信移动客服功能,详情见[环信移动客服文档]
        };
        //TM.logs(JSON.stringify(param));
        uexEasemob.sendLocationMsg(JSON.stringify(param));
    },
    sendVoice:function(id,type,filePath,length,displayName,ext,extObj){//E14 发送语音
        var param = {
            username:id,//单聊时聊天人的userid或者群聊时groupid
            chatType:type,//0-单聊,1-群聊
            filePath:filePath,//语音文件路径
            length:length,//长度(Android必选,iOS可选)
            displayName:displayName//,对方接收时显示的文件名(仅iOS需要)
            //ext: ext || {},//扩展属性(可选参数,String)
            //extObj: extObj || {}//扩展参数(iOS 3.0.22, Android 3.0.23新增可选参数,JSONString extObj存在时ext无效).用于环信移动客服功能,详情见[环信移动客服文档]
        };
        //TM.logs(JSON.stringify(param));
        try{
            uexEasemob.sendVoice(JSON.stringify(param));
        }catch(e){}
    },
    sendVideo:function(id,type,filePath,length,displayName,ext,extObj){//E15 发送视频
        var param = {
            username:id,//单聊时聊天人的userid或者群聊时groupid
            chatType:type,//0-单聊,1-群聊
            filePath:filePath,//语音文件路径
            length:length,//长度(Android必选,iOS可选)
            displayName: displayName,//对方接收时显示的文件名(仅iOS需要)
            ext: ext || {},//扩展属性(可选参数,String)
            extObj: extObj || {}//扩展参数(iOS 3.0.22, Android 3.0.23新增可选参数,JSONString extObj存在时ext无效).用于环信移动客服功能,详情见[环信移动客服文档]
        };
        //TM.logs(JSON.stringify(param));
        uexEasemob.sendVideo(JSON.stringify(param));
    },
    sendCmdMessage:function(type,action,toUsername,ext,extObj){//E16 发送透传消息
        var param = {
            chatType:type,//0-单聊,1-群聊
            action:action,
            toUsername: toUsername,//
            ext: ext || {},//扩展属性(可选参数,String)
            extObj: extObj || {}//扩展参数(iOS 3.0.22, Android 3.0.23新增可选参数,JSONString extObj存在时ext无效).用于环信移动客服功能,详情见[环信移动客服文档]
        };
        //TM.logs(JSON.stringify(param));
        uexEasemob.sendCmdMessage(JSON.stringify(param));
    },
    setNotifyBySoundAndVibrate:function(){//E17 消息提醒相关配置
        var param = {
            enable:1,//0-关闭,1-开启.默认为1 开启新消息提醒
            soundEnable:1,// 0-关闭,1-开启.默认为1 开启声音提醒
            vibrateEnable:1,// 0-关闭,1-开启.默认为1 开启震动提醒
            userSpeaker:1,// 0-关闭,1-开启.默认为1 开启扬声器播放(仅Android可用)
            showNotificationInBackgroud:1,// 0-关闭,1-开启.默认为1.设置后台接收新消息时是否通过通知栏提示(此参数在android环信SDK3.0后已不支持,对应插件版本3.0.22;iOS不完全支持,详见下方说明*)
            acceptInvitationAlways:1,// 0-关闭,1-开启.默认添加好友时为1,是不需要验证的,改成需要验证为0(仅Android可用)
            deliveryNotification:1// 0-关闭 1-开启  默认为1 开启消息送达通知    (仅iOS可用)
        };
        //受iOS后台机制所限,当应用在后台持续一段时间后,环信服务器与App的连接将会断开,此时showNotificationInBackgroud参数无效,需要走APNs通道才能收到新消息以及弹出提示通知.
        //TM.logs(JSON.stringify(param));
        try{
            uexEasemob.setNotifyBySoundAndVibrate(JSON.stringify(param));
        }catch(e){}
    },
    setNotifyBySoundAndVibrateN:function(){//E17 消息提醒相关配置
        var param = {
            enable:0,//0-关闭,1-开启.默认为1 开启新消息提醒
            soundEnable:0,// 0-关闭,1-开启.默认为1 开启声音提醒
            vibrateEnable:0,// 0-关闭,1-开启.默认为1 开启震动提醒
            userSpeaker:0,// 0-关闭,1-开启.默认为1 开启扬声器播放(仅Android可用)
            showNotificationInBackgroud:0,// 0-关闭,1-开启.默认为1.设置后台接收新消息时是否通过通知栏提示(此参数在android环信SDK3.0后已不支持,对应插件版本3.0.22;iOS不完全支持,详见下方说明*)
            acceptInvitationAlways:0,// 0-关闭,1-开启.默认添加好友时为1,是不需要验证的,改成需要验证为0(仅Android可用)
            deliveryNotification:0// 0-关闭 1-开启  默认为1 开启消息送达通知    (仅iOS可用)
        };
        //受iOS后台机制所限,当应用在后台持续一段时间后,环信服务器与App的连接将会断开,此时showNotificationInBackgroud参数无效,需要走APNs通道才能收到新消息以及弹出提示通知.
        //TM.logs(JSON.stringify(param));
        try{
            uexEasemob.setNotifyBySoundAndVibrate(JSON.stringify(param));
        }catch(e){}
    },
    getMessageById:function(msgId){//E18 根据id获取消息记录
        if(!msgId)msgId = this.msgId;
        var param = {
            msgId:msgId//消息ID
        };
        //TM.logs(JSON.stringify(param));
        uexEasemob.getMessageById(JSON.stringify(param));
    },
    getConversationByName:function(username,type){//E19 根据用户名获取conversation对象
        var param = {
            username:username,
            chatType:type //聊天类别 0 - 个人 1 - 群组(仅iOS需要,默认0)
        }
        //TM.logs(JSON.stringify(param));
        uexEasemob.getConversationByName(JSON.stringify(param),function(data){
            var conversation = eval('('+ data +')');
            var chatType = conversation.isGroup;
            var sendId = conversation.chatter;
            if( chatType == 0 || chatType == "0"){
                var cacheRecordSingle = TM.getStorJson("cacheRecordSingle") || {};
                var curreRecord = cacheRecordSingle[sendId];
                if( !curreRecord) {
                    curreRecord = [];
                    cacheRecordSingle[sendId] = curreRecord;
                }
                cacheRecordSingle[sendId] = conversation.messages;
                TM.setStorJson("cacheRecordSingle", cacheRecordSingle);    
                var lastUserPhone = TM.getStorJson("AllUsers").splice(-1);
                var chatJson = {lastUserPhone:cacheRecordSingle};
                TM.setStorJson("chatJson",chatJson);
            }
        });
    },
    getMessageHistory:function(username,type,id,size){//E20 获取聊天记录
        var param = {
            username: username,//单聊时聊天人的userName或者群聊时groupid
            chatType: type,//0-单聊,1-群聊
            startMsgId: id,//获取startMsgId之前的pagesize条消息
            pagesize: size//分页大小,为0时获取所有消息(iOS在3.0.21后不支持获取所有消息),startMsgId可不传
        };
        //TM.logs(JSON.stringify(param));
        try{
            uexEasemob.getMessageHistory(JSON.stringify(param),function(obj){
                var myObj = obj.messages;
                if(obj){
                    /* 由于环信数据结构改变了，此处得重新获取数据  */ 
                    var messages = JSON.stringify(myObj);
                    if( myObj[0].chatType == 1 || myObj[0].chatType == "1"){
                        TMA.evalPopScript("chatrooms","content","historyhtml('" + messages + "')");
                    }else{  //单
                        TMA.evalPopScript("chatroom","content","historyhtml('" + messages + "')");
                    }
                }
            });
        }catch(e){}
    },
    getUnreadMsgCount:function(username,type){//E21 获取未读消息数量
        var param = {
            username: username,//单聊时聊天人的userName或者群聊时groupid
            chatType: type//0-单聊,1-群聊(仅iOS需要,默认0)
        };
        //TM.logs(JSON.stringify(param));
        try{
            uexEasemob.getUnreadMsgCount(JSON.stringify(param),function(data){
                if( data ){
                    var id = TM.getStorage("userUnreadMsgId");
                    appcan.window.evaluatePopoverScript("index2","content","setUnreadMsgCount('"+username+"','"+data.count+"')");
                }else{
                    var id = TM.getStorage("userUnreadMsgId");
                    appcan.window.evaluatePopoverScript("index2","content","setUnreadMsgCount('"+username+"','0')");
                }
            });
        }catch(e){}
    },
    resetUnreadMsgCount:function(username,type){//E22 指定会话未读消息数清零
        var param = {
            username: username,//单聊时聊天人的userName或者群聊时groupid
            chatType: type//0-单聊,1-群聊(仅iOS需要,默认0)
        };
        //TM.logs(JSON.stringify(param));
        var _this = this;
        try{
            uexEasemob.resetUnreadMsgCount(JSON.stringify(param));
            setTimeout(function(){
                _this.getRecentChatters();//获取最近聊天对象信息
                _this.getUnreadMsgCount(username,type);//获取当前会话未读消息数量
                _this.getTotalUnreadMsgCount();//获取未读消息总数
            },200)
        }catch(e){}
    },
    resetAllUnreadMsgCount:function(){//E23 所有未读消息数清零(仅Android可用)
        uexEasemob.resetAllUnreadMsgCount();
    },
    getMsgCount:function(username){//E24 获取消息总数(仅Android可用)
        var param = {
            username: username//单聊时聊天人的userName或者群聊时groupid
        };
        //TM.logs(JSON.stringify(param));
        uexEasemob.getMsgCount(JSON.stringify(param),function(data){
            //TM.logs('getMsgCount:'+data);
        });
    },
    clearConversation:function(username){//E25 清空会话聊天记录(仅Android可用)
        var param = {
            username: username//单聊时聊天人的userName或者群聊时groupid
        };
        //TM.logs(JSON.stringify(param));
        uexEasemob.clearConversation(JSON.stringify(param));
    },
    deleteConversation:function(username,type){//E26 删除所有会话记录(包括本地)
        var param = {
            username: username,//单聊时聊天人的userName或者群聊时groupid
            chatType: type//0-单聊,1-群聊(仅iOS需要,默认0)
        };
        //TM.logs(JSON.stringify(param));
        try{
            uexEasemob.deleteConversation(JSON.stringify(param));
        }catch(e){}
        setTimeout(function(){
            _this.getRecentChatters();//刷新消息列表
        },200)
    },
    removeMessage:function(username,type,msgId){//E27 删除和某个user的整个的聊天记录(包括本地)
        var param = {
            username: username,//单聊时聊天人的userName或者群聊时groupid
            msgId:msgId,
            chatType: type//0-单聊,1-群聊(仅iOS需要,默认0)
        };
        //TM.logs(JSON.stringify(param));
        try{
            uexEasemob.removeMessage(JSON.stringify(param));
        }catch(e){}
    },
    deleteAllConversation:function(){//E28 删除当前会话的某条聊天记录
        uexEasemob.deleteAllConversation();//删除所有会话记录(包括本地)
    },
    getChatterInfo:function(){//E29 获取聊天对象信息
        uexEasemob.getChatterInfo(function(data){
            //TM.logs('getChatterInfo:'+data);
        });
    },
    getTotalUnreadMsgCount:function(){//E30 获取总计未读消息数
        uexEasemob.getTotalUnreadMsgCount(function(data){
            if(data){
                appcan.window.evaluatePopoverScript("index2","content","setUnreadAllMsgCount('"+data.count+"')");
            }
        });
    },
    getRecentChatters:function(){//E31 获取近期聊天对象信息
        //alert("获取最近聊天对象信息：");
        try{
            uexEasemob.getRecentChatters(function(data){
                if( data && data.length > 0 ){
                    var existData = false;
                    $.each(data,function(i,d){
                        if(d.lastMsg)existData = true;
                    })
                    if( TMS.ios && !existData){
                        var chatinfoJSON = {};
                        TM.setStorJson("chatinfoJSON", chatinfoJSON);
                        TMA.evalPopScript("index2","content","clearData()");
                        TMA.evalPopScript("index2","content","setUnreadAllMsgCount(0)");
                        return;
                    }
                    try{
                        var lastUserPhone = TM.getStorJson("AllUsers").splice(-1);
                        var chatinfoJSON = {};
                        chatinfoJSON[lastUserPhone] = data.reverse();
                        TM.setStorJson("chatinfoJSON", chatinfoJSON);
                        TMA.evalPopScript("index2","content","refreshFillMsg()");
                    }catch(e){}
                }else{
                    var chatinfoJSON = {};
                    TM.setStorJson("chatinfoJSON", chatinfoJSON);
                    TMA.evalPopScript("index2","content","clearData()");
                    TMA.evalPopScript("index2","content","setUnreadAllMsgCount(0)");
                }
            });
        }catch(e){}
    },
    getContactUserNames:function(){//E32 获取好友列表
        uexEasemob.getContactUserNames(function(data){
            //TM.logs('getContactUserNames:'+data);
        });
    },
    addContact:function(toAddUsername,reason){//E33 添加好友
        var param = {
            toAddUsername:toAddUsername,//要添加的好友
            reason:reason
        };
        //TM.logs(JSON.stringify(param));
        try{
            uexEasemob.addContact(JSON.stringify(param));
        }catch(e){}
    },
    deleteContact:function(username){//E34 删除好友
        var param = {
            username:username
        };
        //TM.logs(JSON.stringify(param));
        uexEasemob.deleteContact(JSON.stringify(param));
    },
    acceptInvitation:function(username){//E35 同意username的好友请求
        var param = {
            username:username
        };
        //TM.logs(JSON.stringify(param));
        try{
            uexEasemob.acceptInvitation(JSON.stringify(param));
        }catch(e){console.log("line456:"+e)}
    },
    refuseInvitation:function(username,reason){//E36 拒绝username的好友请求
        var param = {
            username:username,
            reason:reason//拒绝好友请求原因(仅iOS需要)
        };
        //TM.logs(JSON.stringify(param));
        uexEasemob.refuseInvitation(JSON.stringify(param));
    },
    getBlackListUsernames:function(){//E37 获取黑名单列表
        uexEasemob.getBlackListUsernames(function(data){
            //TM.logs('getBlackListUsernames:'+data);
        });
    },
    addUserToBlackList:function(username){//E38 把用户加入到黑名单
        var param = {
            username:username
        };
        //TM.logs(JSON.stringify(param));
        uexEasemob.addUserToBlackList(JSON.stringify(param));
    },
    deleteUserFromBlackList:function(username){//E39 把用户从黑名单中移除
        var param = {
            username:username
        };
        //TM.logs(JSON.stringify(param));
        uexEasemob.deleteUserFromBlackList(JSON.stringify(param));
    },
    createPrivateGroup:function(groupName,desc,members,allowInvite,max,msg){//E40 创建私有群
        var param = {
            groupName:groupName,//要创建的群聊的名称
            desc:desc,//群聊简介
            members:members,//群聊成员,为空时这个创建的群组只包含自己
            allowInvite:allowInvite,//是否允许群成员邀请人进群
            maxUsers:max,//最大群聊用户数,可选参数,默认为200,最大为2000
            initialWelcomeMessage:msg//群组创建时发送给每个初始成员的欢迎信息
        };
        //TM.logs(JSON.stringify(param));
        uexEasemob.createPrivateGroup(JSON.stringify(param));
    },
    createPublicGroup:function(groupName,desc,members,needApprovalRequired,max,msg){//E41 创建公开群
        var param = {
            groupName:groupName,//要创建的群聊的名称
            desc:desc,//群聊简介
            members:members,//群聊成员,为空时这个创建的群组只包含自己
            needApprovalRequired:needApprovalRequired,//如果创建的公开群用需要户自由加入,就传false.否则需要申请,等群主批准后才能加入,传true
            maxUsers:max,//最大群聊用户数,可选参数,默认为200,最大为2000
            initialWelcomeMessage:msg//群组创建时发送给每个初始成员的欢迎信息
        };
        //TM.logs(JSON.stringify(param));
        uexEasemob.createPublicGroup(JSON.stringify(param));
    },
    addUsersToGroup:function(isGroupOwner,groupId,members,msg){//E42 群聊加人
        var param = {
            isGroupOwner:isGroupOwner,//是否群主(仅Android需要)
            groupId:groupId,//
            members:members,//群聊成员,为空时这个创建的群组只包含自己
            inviteMessage:msg//群组创建时发送给每个初始成员的欢迎信息
        };
        //TM.logs(JSON.stringify(param));
        uexEasemob.createPublicGroup(JSON.stringify(param));
    },
    removeUserFromGroup:function(groupId,username){//E43 群聊减人
        var param = {
            groupId:groupId,//
            username:username//
        };
        //TM.logs(JSON.stringify(param));
        uexEasemob.removeUserFromGroup(JSON.stringify(param));
    },
    joinGroup:function(groupId,reason,groupName){//E44 加入某个群聊,只能用于加入公开群
        var param = {
            groupId:groupId,//
            reason:reason,//如果群开群是自由加入的,即group.isMembersOnly()为false,此参数不传
            groupName:groupName//
        };
        //TM.logs(JSON.stringify(param));
        uexEasemob.joinGroup(JSON.stringify(param));
    },
    exitFromGroup:function(groupId){//E45 退出群聊
        var param = {
            groupId:groupId
        };
        //TM.logs(JSON.stringify(param));
        uexEasemob.exitFromGroup(JSON.stringify(param));
    },
    exitAndDeleteGroup:function(groupId){//E46 解散群聊
        var param = {
            groupId:groupId
        };
        //TM.logs(JSON.stringify(param));
        uexEasemob.exitAndDeleteGroup(JSON.stringify(param));
    },
    getGroupsFromServer:function(loadCache){//E47 从服务器获取自己加入的和创建的群聊列表
        if(!loadCache)loadCache = false;
        var param = {
            loadCache:loadCache//是否从本地加载缓存,(默认为false,从网络获取)
        };
        //TM.logs(JSON.stringify(param));
        uexEasemob.getGroupsFromServer(JSON.stringify(param),function(data){
            //result://0-成功,1-失败
            //grouplist://List<EMGroup> json格式
            //errorMsg:
            //TM.logs('getGroupsFromServer:'+data);
        });
    },
    getAllPublicGroupsFromServer:function(pageSize,cursor){//E48 获取所有公开群列表
        var param = {
            pageSize:pageSize,//期望结果的数量, 如果 < 0 则一次返回所有结果
            cursor:cursor//获取公开群的cursor,首次调用传空即可
        };
        //TM.logs(JSON.stringify(param));
        uexEasemob.getAllPublicGroupsFromServer(JSON.stringify(param),function(data){
            //result://0-成功,1-失败
            //grouplist:List< EMGroup> json格式 见附录
            //errorMsg:
            //cursor:,//
            //TM.logs('getAllPublicGroupsFromServer:'+data);
        });
    },
    getGroup:function(groupId,loadCache){//E49 获取群详情
        if(!loadCache)loadCache = false;
        var param = {
            groupId:groupId,//
            loadCache:loadCache//是否从本地加载缓存,(默认为false,从网络获取)
        };
        //TM.logs(JSON.stringify(param));
        uexEasemob.getGroup(JSON.stringify(param),function(data){
            //TM.logs('getGroup:'+data);
        });
    },
    blockGroupMessage:function(groupId){//E50 屏蔽群消息
        var param = {
            groupId:groupId
        };
        //TM.logs(JSON.stringify(param));
        try{
            uexEasemob.blockGroupMessage(JSON.stringify(param));
        }catch(e){}
    },
    unblockGroupMessage:function(groupId){//E51 解除屏蔽群
        var param = {
            groupId:groupId
        };
        //TM.logs(JSON.stringify(param));
        try{
            uexEasemob.unblockGroupMessage(JSON.stringify(param));
        }catch(e){}
    },
    changeGroupName:function(groupId,name){//E52 修改群组名称
        var param = {
            groupId:groupId,//
            changedGroupName:name
        };
        //TM.logs(JSON.stringify(param));
        uexEasemob.changeGroupName(JSON.stringify(param));
    },
    blockUser:function(groupId,name){//E53 将群成员拉入群组的黑名单(iOS 3.0.22后支持)
        var param = {
            groupId:groupId,//
            username:name
        };
        //TM.logs(JSON.stringify(param));
        uexEasemob.blockUser(JSON.stringify(param));
    },
    unblockUser:function(groupId,name){//E54 将拉入黑名单的群成员移除(iOS 3.0.22后支持)
        var param = {
            groupId:groupId,//
            username:name
        };
        //TM.logs(JSON.stringify(param));
        uexEasemob.unblockUser(JSON.stringify(param));
    },
    getBlockedUsers:function(groupId){//E55 获取群组的黑名单用户列表(iOS 3.0.22后支持)
        var param = {
            groupId:groupId
        };
        //TM.logs(JSON.stringify(param));
        uexEasemob.getBlockedUsers(JSON.stringify(param),function(data){
            //TM.logs('getBlockedUsers:'+data);
        });
    },
    acceptJoinApplication:function(groupId,name){//E56 批准入群申请, 需要Owner权限(iOS 3.0.22, Android 3.0.23新增接口)
        var param = {
            groupId:groupId,
            username:username
        };
        //TM.logs(JSON.stringify(param));
        uexEasemob.acceptJoinApplication(JSON.stringify(param));
    },
    declineJoinApplication:function(groupId,name,reason){//E57 拒绝入群申请, 需要Owner权限(iOS 3.0.22, Android 3.0.23新增接口)
        var param = {
            groupId:groupId,
            username:username,
            reason:reason
        };
        //TM.logs(JSON.stringify(param));
        uexEasemob.declineJoinApplication(JSON.stringify(param));
    },
    acceptInvitationFromGroup:function(groupId,name){//E58 接受入群邀请(iOS 3.0.22, Android 3.0.23新增接口)
        var param = {
            groupId:groupId,
            username:username
        };
        //TM.logs(JSON.stringify(param));
        uexEasemob.acceptInvitationFromGroup(JSON.stringify(param));
    },
    declineInvitationFromGroup:function(groupId,name,reason){//E59 拒绝入群邀请(iOS 3.0.22, Android 3.0.23新增接口)
        var param = {
            groupId:groupId,
            username:username,
            reason:reason
        };
        //TM.logs(JSON.stringify(param));
        uexEasemob.declineInvitationFromGroup(JSON.stringify(param));
    },
    makeVoiceCall:function(name){//E60 拨打语音通话
        var param = {
            username:username
        };
        //TM.logs(JSON.stringify(param));
        uexEasemob.makeVoiceCall(JSON.stringify(param));
    },
    makeVoiceCall:function(name){//E60 拨打语音通话
        var param = {
            username:username
        };
        //TM.logs(JSON.stringify(param));
        uexEasemob.makeVoiceCall(JSON.stringify(param));
    },
    answerCall:function(){//E61 接听通话
        //TM.logs('接听通话:answerCall');
        uexEasemob.answerCall();
    },
    rejectCall:function(){//E62 重新通话
        //TM.logs('重新通话:rejectCall');
        uexEasemob.rejectCall();
    },
    endCall:function(){//E63 挂断通话
        //TM.logs('挂断通话:endCall');
        uexEasemob.endCall();
    },
    registerRemoteNotification:function(){//E64 注册Apns推送  --------APNS
       //TM.logs('注册Apns推送:registerRemoteNotification');
        var _this = this;
        uexEasemob.registerRemoteNotification(function(data){
            //result;//1-成功 2-失败
            //errorInfo;//注册失败时的错误信息
            //TM.logs('registerRemoteNotification:'+data);
            var data = eval('('+ data +')');
            //if( data.result == 1){
                _this.updatePushOptions("同业云",0);
            //}
        });
    },
    updatePushOptions:function(name,style,nostyle,start,end){//E65 设置apns全局属性  --------APNS
        var param = {
            nickname:name,//昵称
            displayStyle:style || 0,//推送显示类型 0-提示"您有一条新消息" 1- 显示详细消息内容 
            noDisturbingStyle:nostyle || 2,//是否开启免打扰模式 0-全天免打扰 1-自定义时段免打扰 2- 关闭免打扰
            noDisturbingStartH:start,//免打扰模式开始时间  小时(int)
            noDisturbingEndH:end//免打扰模式结束时间  小时(int)
        };
        //TM.logs(JSON.stringify(param));
        if(!name)param = {};//全为可选参数,当传入空值时,即可通过回调获得当前apns全局属性
        uexEasemob.updatePushOptions(param,function(data){
            //TM.logs('updatePushOptions:'+data);
        });
    },
    ignoreGroupPushNotification:function(groupId,isIgnore){//E66 设置指定群组是否接收  --------APNS
        var param = {
            groupId:groupId,//指定的群组Id
            isIgnore:isIgnore//1-屏蔽  2-取消屏蔽
        };
        //TM.logs(JSON.stringify(param));
        uexEasemob.ignoreGroupPushNotification(param,function(data){
            //data.groupIds;//已屏蔽接收推送消息的群列表
            //TM.logs('ignoreGroupPushNotification:'+data);
        });
    },
    initListen:function(){//E9 监听事件
        //alert("启动所有监听事件")
        var _this = this;
        try{
            uexEasemob.onConnected = function(data){
                //alert('onConnected：'+data)
                //TM.logs('onConnected!');
            }
            uexEasemob.onDisconnected = function(data){
                var data = eval('('+ data +')');
                //var param = {
                //    error:,//1-账号被移除,2-账号其他设备登陆,3-连接不到聊天服务器,4-当前网络不可用 
                //};
                if( data.error == 1){
                    
                }else if( data.error == 2){
                    //clearStorage("chatinfo");//清除聊天列表缓存
                    //clearStorage("cacheRecordSingle");//清除聊天缓存
                    //clearStorage("cacheRecord");//清除聊天缓存
                    TM.clearStorage("login_phone");
                    TM.clearStorage("login_password");
                    TM.clearStorage("contactsList");
                    TM.clearStorage("userInfo");
                    TM.clearStorage("searchKeys1");
                    TM.clearStorage("searchKeys2");
                    TM.setStorage("checked0","1");
                    TM.setStorage("checked1","1");
                    TM.setStorage("isSetting", "1");
                    TMA.evalPopScript("index3","content","initData()");
                    TMA.evalScript("index4", "appcan.window.close(0)");
                    try{EB.logout();}catch(e){}
                    try{jPush.stopPush();}catch(e){}
                    try{appcan.window.publish('slidingWin','login');}catch(e){}
                    TMA.openWin({name : "login",data : "login.html"});
                    try{
                        TMA.evalScript("chatroom","appcan.window.close(0)");
                        TMA.evalScript("chatrooms","appcan.window.close(0)");
                    }catch(e){}
                }else if( data.error == 3){
                    TMA.toast("连接不到服务器");
                }else if( data.error == 4){
                    TMA.toast("当前网络不可用 ");
                }
                //TM.logs('onDisconnected:'+data);
            }
            uexEasemob.onNewMessage = function(data){//收到消息
                if(!data)return;
                var obj = eval('(' + data + ')');
                if( messageId_last == obj.messageId ){
                    return;
                }
                messageId_last = obj.messageId;
                _this.msgId = obj.messageId;
                if( obj.chatType == 1 || obj.chatType == "1"){  //群
                    var groupId = obj.to; //接受者
                    var lastUserPhone = TM.getStorJson("AllUsers").splice(-1);
                    var chatJsonGroup = TM.getStorJson("chatJsonGroup") || {};
                    var cacheRecord = {};
                    if( chatJsonGroup && chatJsonGroup[lastUserPhone]){
                        cacheRecord = chatJsonGroup[lastUserPhone];
                    }
                    var curreRecord = cacheRecord[groupId]; 
                    if(!curreRecord){
                        curreRecord = [];
                        cacheRecord[groupId] = curreRecord;
                    }
                    cacheRecord[groupId].push(obj);  
                    chatJsonGroup[lastUserPhone] = cacheRecord;
                    TM.setStorJson("chatJsonGroup",chatJsonGroup);//缓存历史消息
                    try{
                        TMA.evalPopScript("chatrooms","content","newMessage('"+ data +"')");
                    }catch(e){}
                }else{
                    try{
                        var sendId = obj.from;
                        var lastUserPhone = TM.getStorJson("AllUsers").splice(-1);
                        var chatJson = TM.getStorJson("chatJson") || {};
                        var cacheRecordSingle = {};
                        if( chatJson && chatJson[lastUserPhone]){
                            cacheRecordSingle = chatJson[lastUserPhone];
                        }
                        var curreRecord = cacheRecordSingle[sendId];
                        if (!curreRecord) {
                            curreRecord = [];
                            cacheRecordSingle[sendId] = curreRecord;
                        }
                        cacheRecordSingle[sendId].push(obj);
                        chatJson[lastUserPhone] = cacheRecordSingle;
                        TM.setStorJson("chatJson",chatJson);
                        TMA.evalPopScript("chatroom","content","newMessage('"+ data +"')");
                    }catch(e){}
                }
                try{
                    //TMA.evalPopScript("index2","content","fillMsg('"+ data +"',0,true)");
                    _this.getRecentChatters();
                }catch(e){}
            }
            uexEasemob.onCmdMessageReceive = function(data){//透传消息监听
                //TM.logs('onCmdMessageReceive:'+data);
            }
            uexEasemob.onAckMessage = function(data){//消息已读监听
                //alert("消息已读监听：")
                //alert(JSON.stringify(data))
                //TM.logs('onAckMessage:'+data);
            }
            uexEasemob.onDeliveryMessage = function(data){//消息送达监听
                //alert("消息送达监听：")
                //alert(JSON.stringify(data))
            }
            uexEasemob.onContactAdded = function(data){//新增联系人监听(iOS 3.0.22后支持)
                //TM.logs('onContactAdded:'+data);
            }
            uexEasemob.onContactDeleted = function(data){//删除联系人监听(iOS 3.0.22后支持)
                //TM.logs('onContactDeleted:'+data);
            }
            uexEasemob.onContactInvited = function(data){//接到好友申请
                //alert(JSON.stringify(data))
                //TM.logs('onContactInvited:'+data);
                var newFriends = 1;
                if( TM.getStor("newFriends") && TM.getStor("newFriends") !="" ){
                    newFriends = newFriends + paeseInt(TM.getStor("newFriends"));
                }
                TM.setStor("newFriends",newFriends);
                TMA.evalScript("index2","changeDot(1,"+newFriends+")");
            }
            uexEasemob.onContactAgreed = function(data){//好友请求被同意
                //TM.logs('onContactAgreed:'+data);
                var newFriends = 1;
                if( TM.getStor("newFriends") && TM.getStor("newFriends") !="" ){
                    newFriends = paeseInt(TM.getStor("newFriends")) - newFriends;
                }else{
                    newFriends = 0;
                }
                if( newFriends < 0)newFriends = 0;
                TM.setStor("newFriends",newFriends);
                if( newFriends > 0 ){
                    TMA.evalScript("index2","changeDot(1,"+newFriends+")");
                }else{
                    TMA.evalScript("index2","changeDot(0)");
                }
            }
            uexEasemob.onContactRefused = function(data){//好友请求被拒绝
                //TM.logs('onContactRefused:'+data);
                var newFriends = 1;
                if( TM.getStor("newFriends") && TM.getStor("newFriends") !="" ){
                    newFriends = paeseInt(TM.getStor("newFriends")) - newFriends;
                }else{
                    newFriends = 0;
                }
                if( newFriends < 0)newFriends = 0;
                TM.setStor("newFriends",newFriends);
                if( newFriends > 0 ){
                    TMA.evalScript("index2","changeDot(1,"+newFriends+")");
                }else{
                    TMA.evalScript("index2","changeDot(0)");
                }
            }
            uexEasemob.onInvitationDeclined = function(data){//群聊邀请被拒绝
                //TM.logs('onInvitationDeclined:'+data);
            }
            uexEasemob.onInvitationAccpted = function(data){//群聊邀请被同意
                //TM.logs('onInvitationAccpted:'+data);
            }
            uexEasemob.onUserRemoved = function(data){//当前用户被管理员移除出群聊
                //TM.logs('onUserRemoved:'+data);
                var obj = eval('(' + param + ')');
                var data = {};
                data.to = obj.groupId;
                data.chatType = 1;
                data.messageType = "text";
                data.messageBody = {};
                data.messageBody.text = "你被管理员移除群聊";
                data.messageTime = new Date().getTime();
                TMA.evalPopScript("index2","content","removeMsg('"+ obj.groupId +"',1)");
            }
            uexEasemob.onGroupDestroy = function(data){//群聊被创建者解散
                //TM.logs('onGroupDestroy:'+data);
                var obj = eval('(' + param + ')');
                var data = {};
                data.to = obj.groupId;
                data.chatType = 1;
                data.messageType = "text";
                data.messageBody = {};
                data.messageBody.text = "群聊已被创建者解散";
                data.messageTime = new Date().getTime();
                TMA.evalPopScript("index2","content","removeMsg('"+ obj.groupId +"',1)");
            }
            uexEasemob.onApplicationReceived = function(data){//用户申请加入群聊,收到加群申请
                //TM.logs('onApplicationReceived:'+data);
            }
            uexEasemob.onApplicationAccept = function(data){//加群申请被同意
                //TM.logs('onApplicationAccept:'+data);
            }
            uexEasemob.onApplicationDeclined = function(data){//加群申请被拒绝
                //TM.logs('onApplicationDeclined:'+data);
            }
            uexEasemob.onGroupUpdateInfo = function(data){//群组信息更新的监听(仅iOS)
                //TM.logs('onGroupUpdateInfo:'+data);
            }
            uexEasemob.onDidJoinedGroup = function(data){//自动加入群组监听(3.0.22新增接口)
                //TM.logs('onDidJoinedGroup:'+data);
            }
            uexEasemob.onReceiveGroupInvitation = function(data){//收到群组邀请监听
                //TM.logs('onReceiveGroupInvitation:'+data);
            }
            uexEasemob.onCallReceive = function(data){//实时语音监听
                //TM.logs('onCallReceive:'+data);
            }
            uexEasemob.onCallStateChanged = function(data){//通话状态监听
                //TM.logs('onCallStateChanged:'+data);
            }
            uexEasemob.onApnsLaunch = function(data){//IOS-若APP是通过点击apns推送调起的,当插件初始化时会触发此回调
                //alert(data)
                //TM.logs('onApnsLaunch:'+data);
            }
            uexEasemob.sendHasReadResponseForMessage = function(data){//发送消息已读回执
                //TM.logs('sendHasReadResponseForMessage:'+data);
            }
            uexEasemob.onMessageSent = function(data){//消息已发送监听
                //isSuccess:,//消息是否发生成功 true/false
                //errorStr:,//发送失败的原因 当isSuccess为false时才有此项
                //message:,//被发送的消息 EMMessage结构的json
                //所有send开头的发送消息的API均会触发此监听
                //此监听仅表示消息是否成功发送至环信服务器,不能以此判断接收人是否收到消息
                //alert("消息已发送监听：")
                //alert(JSON.stringify(data))
                try{TMA.closetoast()}catch(e){}
                //TM.logs('onMessageSent:'+data);
            }
            uexEasemob.onGroupCreated = function(data){//群组建立监听
                //isSuccess:,//群组是否创建成功 true/false
                //errorStr:,//创建失败的原因 仅isSuccess传false时会有此参数
                //group:,//EMGroup的json字符串,被建立的群组信息
                //TM.logs('onGroupCreated:'+data);
                // if (publicGroupId==null){//两次创建群的操作,先创建公开群
                    // publicGroupId=result.group.groupId;
                // }else{
                    // privateGroupId=result.group.groupId;
                // }
                if( data){
                    var json = eval('('+ data +')');
                    if( json.isSuccess){
                        var group = json.group;
                        var memebers = TM.getStorJson("arrsphone").join();
                        TMA.ajax({
                            url : "chatGorup/createGroupByEasemob",
                            data:{
                                memberStr:memebers,
                                groupName:group.groupName,
                                groupOwner:group.owner,
                                easemobId:group.groupId,
                                kindergartenId:TM.getStorage("kindergardenid"),
                                classId:TM.getStorage("classid")
                            },  
                            successx : function(data) {
                                if( !data.success){
                                    $toast("创建失败，稍后重试");                    
                                }else{
                                    appcan.window.closeToast();
                                    TM.setStorage('chatid',group.groupId);
                                    TM.setStorage('chatname', group.groupName);//昵称
                                    TMA.openWin({name:"chatrooms",data:"friend/chatrooms.html"});
                                }
                            }
                        });
                    }else{
                        TMA.toast(json.errorStr);
                    }
                }
            }
        }catch(e){}
    }
}