/*
 *  index.html
 *  author by TMJ 2018-06-07 15:28:10
 *  
 * */
/**
 *  资金面情绪指数 
 */
//获取资金面情绪指数
function getExponentChart(){
    TMA.ajax({
        url: "topfit/japi/app/home/getExponentChart",
        data: {},
        successx : function(data){
            console.log("获取资金面情绪指数:",data);
            if( data.obj){
                if( data.obj.qsc)$("#qsc").text(data.obj.qsc).removeClass("font3");// 全市场
                if( data.obj.dh)$("#dh").text(data.obj.dh).removeClass("font3");// 大中行
                if( data.obj.zxh)$("#zxh").text(data.obj.zxh).removeClass("font3");// 中小行
                if( data.obj.fy)$("#fy").text(data.obj.fy).removeClass("font3");// 非银
                listDataForKLine(0);
            }
        }
    },true,true);
}
//获取指数数据
function listDataForKLine(type){
    TMA.ajax({
        url: "topfit/japi/app/home/listDataForKLine",
        data: {type:type},
        successx : function(data){
            console.log("获取指数数据:",data);
            if( data.obj){
                if( data.obj.ranges && data.obj.ranges.length > 0){
                    var rl = data.obj.ranges.length - 1;
                    var timeObj = data.obj.ranges[rl];
                    var nowDate = timeObj[5].substr(2,8);
                    var obj9 = timeObj[9] == "--"? ("&nbsp;"+timeObj[9]):timeObj[9];
                    var obj10 = timeObj[10] == "--"? ("&nbsp;"+timeObj[10]):timeObj[10];
                    var obj11 = timeObj[11] == "--"? ("&nbsp;"+timeObj[11]):timeObj[11];
                    var obj12 = timeObj[12] == "--"? ("&nbsp;"+timeObj[12]):timeObj[12];
                    var rlHtml = "";
                    rlHtml += '<p>'+nowDate+'</p>'
                    + '<p>&nbsp;<span>'+timeObj[5].substr(11,5)+'</span>&nbsp;<span class="colorB">'+obj9+'</span></p>'
                    + '<p>&nbsp;<span>'+timeObj[6].substr(11,5)+'</span>&nbsp;<span class="colorB">'+obj10+'</span></p>'
                    + '<p>&nbsp;<span>'+timeObj[7].substr(11,5)+'</span>&nbsp;<span class="colorB">'+obj11+'</span></p>'
                    + '<p>&nbsp;<span>'+timeObj[8].substr(11,5)+'</span>&nbsp;<span class="colorB">'+obj12+'</span></p>'
                    $("#times"+type).html(rlHtml);
                    createHeightCharts(type,data);
                    var pi = 12;
                    while(8 < pi < 13){
                        if( timeObj[pi] != "--"){
                            $("#sentiment").text(TM.subS(timeObj[pi-4],16));
                            break;
                        }
                        pi --;
                    }
                }
            }
        }
    },false,true);
}
//创建 heightCharts
function createHeightCharts(type,data){
    var em = parseInt($("body").css("font-size"));
    var title = data.obj.seriesName;                 
    var ohlc = [];
    for (var i =0;i<data.obj.ranges.length;i++) {
        ohlc.push([
            data.obj.ranges[i][0], // the date
            data.obj.ranges[i][1], // open
            data.obj.ranges[i][2], // high
            data.obj.ranges[i][3], // low
            data.obj.ranges[i][4] // close
        ]);
    }
    var chartsData = {
        rangeSelector :{
            enabled: false,
            inputDateFormat: '%Y-%m-%d',
            inputEnabled:false,
            selected:0
        },
        scrollbar:{
            enabled: false
        },
        navigator:{
            enabled: false
        },
        credits:{ 
            text:'数据来源：上海国际货币经纪',
            href:'javascript:;',
            position:{align: 'left',x: 20}
        },
        chart:{
            panning: false,
            pinchType: "",
            marginLeft: 50,
            marginRight: 0,
            marginTop:0
        },
        xAxis :
        {
            type : 'datetime',
            dateTimeLabelFormats :
            {
                millisecond: '%H:%M:%S.%L',
                second: '%H:%M:%S',
                minute: '%H:%M',
                hour: '%H:%M',
                day: '%m-%d',
                week: '%m-%d',
                month: '%y-%m',
                year: '%Y'
            },
            tickInterval: 7 * 24 * 3600 * 1000,
            lineColor: "#F1F1F1"
        },
        yAxis : {
            opposite:false,
            alternateGridColor: '#F8F8FD',
            gridLineColor: '#F1F1F1',
            tickAmount: 6,
            min: 0,
            offset: 0
        },
        series : [{
            type : 'candlestick',
            crosshairs : [
                    true,true
            ],
            color: '#11C192',
            lineColor: '#11C192',
            upColor: '#F2262B',
            upLineColor: '#F2262B',
            name : title,
            data : ohlc
        }],
        tooltip : {
            hideDelay : 500,
            split: false
        }
    }
    if( TMS.ios ){
        //$(".highchartsBox").css("height","12em");
        $(".commonTem .times").css("height","9.61em");
        //$(".commonTem .times p").css("line-height","2.65em");
        var plotOptions = {
            series: {
                borderWidth: 0,
                groupPadding: .35
            }
        }
        chartsData.plotOptions = plotOptions;
        //chartsData.yAxis.tickPixelInterval = 30;
        chartsData.yAxis.offset = -0.85*em;//改变Y轴数据显示距离左边距距离
        chartsData.chart.marginLeft = 1.3*em;//改变chat距离左边框距离
        chartsData.chart.spacingBottom = 1.25*em;//抬高底部X轴文字，避免遮挡数据来源描述文字
        chartsData.credits.position.x = .65*em;//来源描述文字距离左边距离
    }else{
        $(".commonTem .times").css("height","10.02em");
        var tooltipA = {
            shared: true,
            split: false,
            style:{fontSize: .7*em+"px"},
            headerFormat: '<small>{point.key}</small><br/>',
            dateTimeLabelFormats: {
                hour: '%Y-%m-%d %H:%M'
            }
        };
        chartsData.tooltip = tooltipA;//修改弹框样式,避免android端显示异常
        var creditsSty = {fontSize: .7*em+"px"};
        var xAxisSty = {style:{fontSize: .6*em+"px"}};
        var yAxisSty = {style:{fontSize: .6*em+"px"}};
        chartsData.credits.style = creditsSty;
        chartsData.xAxis.labels = xAxisSty;
        chartsData.yAxis.labels = yAxisSty;
        chartsData.yAxis.offset = -0.15*em;//改变Y轴数据显示距离左边距距离
        chartsData.chart.marginLeft = 1.25*em;//改变chat距离左边框距离
        chartsData.chart.spacingBottom = 1.25*em;//抬高底部X轴文字，避免遮挡数据来源描述文字
        chartsData.credits.position.x = .65*em;//来源描述文字距离左边距离
    }
    $("#highcharts"+type).highcharts ('StockChart',chartsData);
    //监听滑动滑动事件
    $("#highcharts0,#highcharts1,#highcharts2,#highcharts3").on("touchstart",function(){
        appcan.window.disableBounce();
    })
    $("#highcharts0,#highcharts1,#highcharts2,#highcharts3").on("touchend",function(){
        appcan.window.enableBounce();
    })
}
//资金面情绪指数
appcan.button(".sentiment .classify li", "", function () {
    event.stopPropagation();
    event.preventDefault();
    var clyLiIndex = $(this).index();
    $(".pActive").removeClass("pActive");
    $(".colorLinear1").removeClass("colorLinear1");
    $(this).addClass("pActive");
    $(this).find("p").addClass("colorLinear1");
    $(".highchartsBox").addClass("hideDiv");
    $("#highcharts"+clyLiIndex).parent().removeClass("hideDiv");
    listDataForKLine(clyLiIndex);
});
/**
 *  基准利率 
 */
function searchShiborApi(){
    TMA.ajax({
        url: "topfit/japi/benchmarksApi/searchShiborApi",
        data: {},
        successx : function(data){
            console.log("基准利率:",data);
            if( data.obj){
                createShibor(data.obj);
            }
        }
    },false,true);
}
//Shibor
function createShibor(data){
    $.each(data,function(i,d){
        if( i && i.split("/").length == 2 ){
            i = "ON";
        }
        var rate = "暂无";
        if( d.rate){
            rate = d.rate + "<span class='symbol2'>%</span>";
            $("#"+i).find(".font2_2").removeClass("fontNull");
        }
        var rateChange = "&nbsp;";
        if( d.rateChange && d.rate)rateChange = d.rateChange + "<span class='symbol'>bp</span>"; 
        $("#"+i).find(".font2_2").html(rate);
        $("#"+i).find(".pMar").html(rateChange);
        if( d.rateChange > 0 && d.rate){
            $("#"+i).find(".font2_2").addClass("fontCR");
            var triangleH = '<img src="img/index/triangle_red.png" />';
            $("#"+i).find(".pMar").html(rateChange+triangleH);
        }
        if( d.rateChange < 0 && d.rate){
            $("#"+i).find(".font2_2").addClass("fontCG");
            var triangleH = '<img src="img/index/triangle_green.png" />';
            $("#"+i).find(".pMar").html(rateChange+triangleH);
        }
        $("#ShiborTime").text(TM.subS(d.updateTime,10));
    });
}
/**
 *  回购定盘利率 
 */
function searchRepurchaseSet(){
    TMA.ajax({
        url: "topfit/japi/benchmarksApi/searchRepurchaseSet",
        data: {},
        successx : function(data){
            console.log("回购定盘利率:",data);
            if( data.obj){
                createChaseSet(data.obj);
            }
        }
    },false,true);
}
//
function createChaseSet(data){
    $.each(data,function(i,d){
        var rate = "暂无";
        if( d.rate){
            rate = d.rate + "<span class='symbol2'>%</span>";
            $("#"+i).find(".font2_2").removeClass("fontNull");
        }else{
            if( TMS.ios){$(".dataSwiper li").css("min-height","5.5em");}
        }
        var rateChange = "&nbsp;";
        if( d.rateChange && d.rate)rateChange = d.rateChange + "<span class='symbol'>bp</span>"; 
        $("#"+i).find(".font2_2").html(rate);
        $("#"+i).find(".pMar").html(rateChange);
        if( d.rateChange > 0  && d.rate){
            $("#"+i).find(".font2_2").addClass("fontCR");
            var triangleH = '<img src="img/index/triangle_red.png" />';
            $("#"+i).find(".pMar").html(rateChange+triangleH);
        }
        if( d.rateChange < 0  && d.rate){
            $("#"+i).find(".font2_2").addClass("fontCG");
            var triangleH = '<img src="img/index/triangle_green.png" />';
            $("#"+i).find(".pMar").html(rateChange+triangleH);
        }
        $("#ChaseSetTime").text(TM.subS(d.updateTime,10));
    });
}
/**
 *  质押式回购
 */
function searchCollateralisedRepo(){
    TMA.ajax({
        url: "topfit/japi/benchmarksApi/searchCollateralisedRepo",
        data: {},
        successx : function(data){
            console.log("质押式回购:",data);
            if( data.obj){
                createCollateralisedRepo(data.obj);
            }
        }
    },false,true);
}
//
function createCollateralisedRepo(data){
    $.each(data,function(i,d){
        var rate = "暂无";
        if( d.rate){
            rate = d.rate + "<span class='symbol2'>%</span>";
            $("#"+i).find(".font2_2").removeClass("fontNull");
        }else{
            if( TMS.ios){$(".dataSwiper li").css("min-height","5.5em");}
        }
        var rateChange = "&nbsp;";
        if( d.rateChange && d.rate)rateChange = d.rateChange + "<span class='symbol'>bp</span>"; 
        $("#"+i).find(".font2_2").html(rate);
        $("#"+i).find(".pMar").html(rateChange);
        if( d.rateChange > 0  && d.rate){
            $("#"+i).find(".font2_2").addClass("fontCR");
            var triangleH = '<img src="img/index/triangle_red.png" />';
            $("#"+i).find(".pMar").html(rateChange+triangleH);
        }
        if( d.rateChange < 0  && d.rate){
            $("#"+i).find(".font2_2").addClass("fontCG");
            var triangleH = '<img src="img/index/triangle_green.png" />';
            $("#"+i).find(".pMar").html(rateChange+triangleH);
        }
        $("#ralisedRepoTime").text(TM.subS(d.updateTime,16));
    });
}
/**
 *  信用拆借
 */
function searchCreditLoan(){
    TMA.ajax({
        url: "topfit/japi/benchmarksApi/searchCreditLoan",
        data: {},
        successx : function(data){
            console.log("信用拆借:",data);
            if( data.obj){
                createSearchCreditLoan(data.obj);
            }
        }
    },false,true);
}
//信用拆借
function createSearchCreditLoan(data){
    $.each(data,function(i,d){
        var rate = "暂无";
        if( d.rate){
            rate = d.rate + "<span class='symbol2'>%</span>";
            $("#"+i).find(".font2_2").removeClass("fontNull");
        }else{
            if( TMS.ios){$(".dataSwiper li").css("min-height","5.5em");}
        }
        var rateChange = "&nbsp;";
        if( d.rateChange && d.rate)rateChange = d.rateChange + "<span class='symbol'>bp</span>";
        $("#"+i).find(".font2_2").html(rate);
        $("#"+i).find(".pMar").html(rateChange);
        if( d.rateChange > 0  && d.rate){
            $("#"+i).find(".font2_2").addClass("fontCR");
            var triangleH = '<img src="img/index/triangle_red.png" />';
            $("#"+i).find(".pMar").html(rateChange+triangleH);
        }
        if( d.rateChange < 0  && d.rate){
            $("#"+i).find(".font2_2").addClass("fontCG");
            var triangleH = '<img src="img/index/triangle_green.png" />';
            $("#"+i).find(".pMar").html(rateChange+triangleH);
        }
        $("#creditLoanTime").text(TM.subS(d.updateTime,16));
    });
    //买断式回购
    searchOutrightRepo();
}
/**
 *  买断式回购 
 */
function searchOutrightRepo(){
    TMA.ajax({
        url: "topfit/japi/benchmarksApi/searchOutrightRepo",
        data: {},
        successx : function(data){
            console.log("买断式回购 :",data);
            if( data.obj){
                createSearchOutrightRepo(data.obj);
            }else{
                initSwiper();
            }
        },
        errorx : function(){
            initSwiper();
        }
    },false,true);
}
//买断式回购
function createSearchOutrightRepo(data){
    var outrightRepoUl = '';
    $.each(data,function(i,d){
        var rate = "暂无";
        if( d.rate){
            rate = d.rate + "<span class='symbol2'>%</span>";
            $("#"+i).find(".font2_2").removeClass("fontNull");
        }
        var rateChange = "&nbsp;";
        if( d.rateChange && d.rate)rateChange = d.rateChange + "<span class='symbol'>bp</span>";
        var fontCR = "";
        if( d.rateChange > 0 && d.rate){
            fontCR = "fontCR";
            rateChange += '<img src="img/index/triangle_red.png" />';
        }
        if( d.rateChange < 0 && d.rate){
            fontCR = "fontCG";
            rateChange += '<img src="img/index/triangle_green.png" />';
        }
        outrightRepoUl += '<li class="swiper-slide" id="'+i+'"><p>'+i+'</p><p class="font2_2 '+fontCR+'">'+rate+'</p><p class="pMar">'+rateChange+'</p></li>'
        $("#outrightRepoTime").text(TM.subS(d.updateTime,16));
    });
    $("#outrightRepoUl").html(outrightRepoUl);
    if( TMS.ios){$(".dataSwiper li").css("min-height","5.5em");}
    initSwiper();
}