/*
 *  desc Jpush 极光推送4.0
 *  Based on the appcan 4.0 integrated package
 *  author by TMJ 
 *  version: V4.0.0
 *  base on V3.1.1
 *  
 */
/*  Directory
 *  appcan.logs(msg) //把日志输出到控制台
 *  config：配置开发参数信息
 *  
 */
var jPush = {
    connect:false,
    stopPush:function(){//停止推送服务
        try{
            uexJPush.stopPush();
        }catch(e){}
    },
    resumePush:function(){///恢复推送服务
        try{
            uexJPush.resumePush()
        }catch(e){}
    },
    setAlias:function(name){//设置别名
        var id = name.replace(/-/g,"");
        var json = {alias:id};
        try{
            uexJPush.setAlias(json, function(error,data) {
               if(!error){
                    //alert(JSON.stringify(data));
               }else{
                    //alert("设置失败");
               }
            });
        }catch(e){console.log(e)}
    },
    setTags:function(){//设置标签
        var tags=new Array("tag1","tag2","tag3");
        var json = {tags:tags};
        try{
            uexJPush.setTags(json, function(error,data) {
                if(!error){
                    //alert(JSON.stringify(data));
               }else{
                    //alert("设置失败");
               }
            });
        }catch(e){}
    },
    setAliasAndTags:function(){//同时设置别名与标签
        var tags=new Array("tag4","tag5","tag6");
        var json = {
            alias:"alias66",
            tags:tags
        };
        try{
            uexJPush.setAliasAndTags(json, function(error,data) {
                if(!error){
                    //alert(JSON.stringify(data));
               }else{
                    //alert("设置失败");
               }
            });
        }catch(e){}
    },
    getRegistrationID:function(){///取得应用程序对应的 RegistrationID
        var id = uexJPush.getRegistrationID();
        //alert(id);
    },
    clearAllNotifications:function(){//清除所有通知,仅支持Android
        try{
            uexJPush.clearAllNotifications();
        }catch(e){}
    },
    clearNotificationById:function(){///根据Id清除某条通知,仅支持Android
        var params = {
            notificationId:123456789
        };
        var data = JSON.stringify(params);
        try{
            uexJPush.clearNotificationById(data);
        }catch(e){}
    },
    getConnectionState:function(){//获取推送连接状态
        try{
            uexJPush.getConnectionState(function(error) {
                if(!error){
                    this.connect = true;//alert("已连上");
               }else{
                    this.connect = false;//alert("未连接");
               }
            });
        }catch(e){}
    },
    addLocalNotification:function(title,content,name,num,timer){//添加一个本地通知
        var json = {
            builderId:0,
            title:title,
            content:content,
            extras:{"name":name},
            notificationId: num || 1,
            broadCastTime:timer || 1000
        };
        try{
            uexJPush.addLocalNotification(json);
        }catch(e){}
    },
    removeLocalNotification:function(){//移除一个本地通知
        var notificationId=3;
        var json = {
            notificationId:notificationId
        };
        try{
            uexJPush.removeLocalNotification(json);
        }catch(e){}
    },
    clearLocalNotifications:function(){//移除所有的通知
        try{
            uexJPush.clearLocalNotifications();
        }catch(e){}
    },
    setBadgeNumber:function(){//设置badge值
        try{
            uexJPush.setBadgeNumber(0);
        }catch(e){}
    },
    showNotificationAlertInForeground:function(){//设置应用在前台时是否显示通知气泡
        try{
            uexJPush.showNotificationAlertInForeground(flag)
        }catch(e){}
    }
}
