/**
 *  author by Sweet
 *  time on 2018-11-03 16:56:10
 *  desc：hightcharts model - highstock
 *  1.双折线图;2.折线图+柱状图 ;3.折线图
 */
/* 双折线图   只有一边-收益率*/
var setHighStock = function(js1,js2,firstDay){
    if(!firstDay)return;
    var json1 = [];
    var json2 = [];
    if(js1 && js1.length > 0)json1 = js1;
    if(js2 && js2.length > 0)json2 = js2;
    var seriesData = [];
    var data1 = {
            type: 'spline',
            name: 'BID',
            color: '#FD676E',
            lineWidth: 5,
            //5, 4.7, 4.9, 4.5, 4.6, 3.6, 4.2, 4.1, 2.9, 3.2, 3, 3.9
            data: json1
    };
    var data2 = {
            type: 'spline',
            name: 'OFR',
            color: '#4E60FE',
            lineWidth: 5,
            //yAxis: 1,
            //-3.9, -2.2, -3.5, -3.8, -3.5, -3.9, -1, -5.9, -5.9, -5.9, -5.9, -2.4
            data: json2
    };
    if( TMS.ios ){
        data1.lineWidth = 2;
        data2.lineWidth = 2;
    }
    seriesData.push(data1);
    seriesData.push(data2);
    console.log(seriesData);
    var em = parseInt($("body").css("font-size"));
    var chartObj = {
        chart: {
            type:'spline',
            spacing:[0,10, 30, 0]
        },
        rangeSelector :{
            enabled: false,
            inputDateFormat: '%Y-%m-%d',
            inputEnabled:false,
            selected:0
        },
        scrollbar:{
            enabled: true
        },
        navigator:{
            enabled: true,
            handles: {}
        },
        credits:{ 
            text:'',
            href:'javascript:;'
        },
        xAxis: {
            type: 'datetime',
            dateTimeLabelFormats: {
                day: '%m-%d'
            },
            crosshair: false,
            labels:{style:{fontSize: .6*em,color: '#C0C0C0'}},
            tickLength: 0
        },
        yAxis: {
                //tickInterval: 0.5,
                opposite: false,
                //min: 2,
                //max: 5,
                //tickInterval: .5,
                title: {
                    text: '收益率(%)',
                    style: {fontSize: .6*em,color: '#C0C0C0'},
                    x: 0.5*em
                },
                labels:{style:{fontSize: .6*em,color: '#C0C0C0'}},
                //tickPositions: [2,2.5,3,3.5,4,4.5,5,5.5],
                plotLines: [{
                                 value: 0,
                                 width: 1,
                                 color: '#C0C0C0'
                           }]
        },
        plotOptions: {
            spline: {
                states: {
                    hover: {
                        lineWidth: 2
                    }
                },
            },
            series:{
                pointStart: Date.UTC(firstDay.y, firstDay.m, firstDay.d),
                //pointIntervalUnit: 'day',
                //pointInterval: 1 * 24 * 3600 * 1000,// 间隔2天
                marker: {
                    enabled: true,
                    radius: 5,
                    symbol: 'circle'
                }
            }
        },
        dataLabels: {
            enabled: true
        },
        series: seriesData,
        legend: {
            itemStyle: {color: "#000",fontWeight:'normal', fontSize:.6*em},
            itemHoverStyle: {color: "#FD676E"},
            itemHiddenStyle: {color: "#606063"},
            verticalAlign: "top",
            align: "right",
            itemMarginBottom:10,
            symbolPadding:10,
            symbolWidth: 10,
            enabled: true,
            y:0,
            x:0,
            symbolHeight: 10
        },
        tooltip : {
            hideDelay : 500,
            split: false,
            shared: true,
            style: {},
            dateTimeLabelFormats: {}
        }
    };
    if( TMS.ios ){
        chartObj.plotOptions.series.marker.radius = 2;
        chartObj.legend.symbolWidth = 0;
    }else if( TMS.isAndroid ){
        chartObj.plotOptions.series.marker.radius = 0.1 * em;
        chartObj.chart.spacing = [ 10,10, 30, 0];
        chartObj.tooltip.style.fontSize = .75 * em + "px";
        chartObj.tooltip.headerFormat = '<small>{point.key}</small><br/>';
        chartObj.tooltip.dateTimeLabelFormats.hour = '%Y-%m-%d %H:%M';
        chartObj.scrollbar.height = 1.25 * em;
        chartObj.scrollbar.borderWidth = 2.5 * em;
        chartObj.navigator.height = 2.5 * em;
        chartObj.navigator.handles.height = 1.5 * em;
        chartObj.navigator.handles.width = 1 * em;
        chartObj.navigator.handles.fontSize = .75 * em;
    }
    try{
        var chart = Highcharts.stockChart('highcharts', chartObj);
    }catch(e){console.log(e)}
}
/* 双折线图  */
var setHighStock1 = function(js1,js2,firstDay){
    if(!firstDay)return;
    var json1 = [];
    var json2 = [];
    if(js1 && js1.length > 0)json1 = js1;
    if(js2 && js2.length > 0)json2 = js2;
    var seriesData = [];
    var data1 = {
            type: 'spline',
            name: 'BID',
            color: '#FD676E',
            lineWidth: 5,
            //5, 4.7, 4.9, 4.5, 4.6, 3.6, 4.2, 4.1, 2.9, 3.2, 3, 3.9
            data: json1
    };
    var data2 = {
            type: 'spline',
            name: 'OFR',
            color: '#4E60FE',
            lineWidth: 5,
            yAxis: 1,
            //-3.9, -2.2, -3.5, -3.8, -3.5, -3.9, -1, -5.9, -5.9, -5.9, -5.9, -2.4
            data: json2
    };
    if( TMS.ios ){
        data1.lineWidth = 2;
        data2.lineWidth = 2;
    }
    seriesData.push(data1);
    seriesData.push(data2);
    var em = parseInt($("body").css("font-size"));
    var chartObj = {
        chart: {
            type:'spline',
            spacing:[0,10, 30, 0]
        },
        rangeSelector :{
            enabled: false,
            inputDateFormat: '%Y-%m-%d',
            inputEnabled:false,
            selected:0
        },
        scrollbar:{
            enabled: true
        },
        navigator:{
            enabled: true,
            handles: {}
        },
        credits:{ 
            text:'',
            href:'javascript:;'
        },
        xAxis: {
            type: 'datetime',
            dateTimeLabelFormats: {
                day: '%m-%d'
            },
            crosshair: false,
            labels:{style:{fontSize: .6*em,color: '#C0C0C0'}},
            tickLength: 0
        },
        yAxis: [
            {
                //tickInterval: 0.5,
                opposite: false,
                //min: 2,
                //max: 5,
                //tickInterval: .5,
                title: {
                    text: '收益率(%)',
                    style: {fontSize: .6*em,color: '#C0C0C0'},
                    x: 0.5*em
                },
                labels:{style:{fontSize: .6*em,color: '#C0C0C0'}},
                //tickPositions: [2,2.5,3,3.5,4,4.5,5,5.5],
                plotLines: [{
                                 value: 0,
                                 width: 1,
                                 color: '#C0C0C0'
                           }]
            },
            {
                //tickInterval: 0.5,
                opposite: true,
                //min: -8,
                //max: 4,
                //tickInterval: 2,
                labels:{style:{fontSize: .6*em,color: '#C0C0C0'}},
                //tickPositions: [-8,-6,-4,-2,0,2,4,6],
                plotLines: [{
                                 value: 0,
                                 width: 1,
                                 color: '#C0C0C0'
                           }]
            }
        ],
        plotOptions: {
            spline: {
                states: {
                    hover: {
                        lineWidth: 2
                    }
                },
            },
            series:{
                pointStart: Date.UTC(firstDay.y, firstDay.m, firstDay.d),
                //pointIntervalUnit: 'day',
                pointInterval: 1 * 24 * 3600 * 1000,// 间隔2天
                marker: {
                    enabled: true,
                    radius: 5,
                    symbol: 'circle'
                }
            }
        },
        dataLabels: {
            enabled: true
        },
        series: seriesData,
        legend: {
            itemStyle: {color: "#000",fontWeight:'normal', fontSize:.6*em},
            itemHoverStyle: {color: "#FD676E"},
            itemHiddenStyle: {color: "#606063"},
            verticalAlign: "top",
            align: "right",
            itemMarginBottom:10,
            symbolPadding:10,
            symbolWidth: 10,
            enabled: true,
            y:0,
            x:0,
            symbolHeight: 10
        },
        tooltip : {
            hideDelay : 500,
            split: false,
            shared: true,
            style: {},
            dateTimeLabelFormats: {}
        }
    };
    if( TMS.ios ){
        chartObj.plotOptions.series.marker.radius = 2;
        chartObj.legend.symbolWidth = 0;
    }else if( TMS.isAndroid ){
        chartObj.plotOptions.series.marker.radius = 0.1 * em;
        chartObj.chart.spacing = [ 10,10, 30, 0];
        chartObj.tooltip.style.fontSize = .75 * em + "px";
        chartObj.tooltip.headerFormat = '<small>{point.key}</small><br/>';
        chartObj.tooltip.dateTimeLabelFormats.hour = '%Y-%m-%d %H:%M';
        chartObj.scrollbar.height = 1.25 * em;
        chartObj.scrollbar.borderWidth = 2.5 * em;
        chartObj.navigator.height = 2.5 * em;
        chartObj.navigator.handles.height = 1.5 * em;
        chartObj.navigator.handles.width = 1 * em;
        chartObj.navigator.handles.fontSize = .75 * em;
    }
    try{
        var chart = Highcharts.stockChart('highcharts', chartObj);
    }catch(e){console.log(e)}
}
/*  折线图+柱状图  */
var setHighStock2 = function(js1,js2,firstDay,desc){
    if( !firstDay){
        firstDay = {y:2018,m:11,d:29};
    }
    var json111 = [
        ['2018/6/20',2.3],
        ['2018/6/21',2.65],
        ['2018/6/22',2.65],
        ['2018/6/23',2.6],
        ['2018/6/24',2.65],
        ['2018/6/25',2.7],
        ['2018/6/26',2.8],
        ['2018/6/27',2.77],
        ['2018/6/28',2.7],
        ['2018/6/29',2.65],
        ['2018/6/30',2.6],
        ['2018/6/31',2.75]
    ].map(function (d) {
        return [new Date(d[0]).getTime(), d[1]];
    });
    var json2222 = [
        ['2018/6/20',1],
        ['2018/6/21',7],
        ['2018/6/22',30],
        ['2018/6/23',4],
        ['2018/6/24',59],
        ['2018/6/25',58],
        ['2018/6/26',56],
        ['2018/6/27',6],
        ['2018/6/28',20],
        ['2018/6/29',6.5],
        ['2018/6/30',12],
        ['2018/6/31',6.5]
    ].map(function (d) {
        return [new Date(d[0]).getTime(), d[1]];
    });
    var json1 = [];
    var json2 = [];
    if(js1 && js1.length > 0)json1 = js1;
    if(js2 && js2.length > 0)json2 = js2;
    var seriesData = [];
    var text1 = "BID";
    var text2 = "OFR";
    if( desc){
        text1 = desc[0];
        text2 = desc[1];
    }
    var data1 = {
            type: 'spline',
            zIndex: 2,
            name: text1,
            color: '#FD676E',
            lineWidth: 5,
            //5, 4.7, 4.9, 4.5, 4.6, 3.6, 4.2, 4.1, 2.9, 3.2, 3, 3.9
            data: json1
            
    };
    var data2 = {
            type: 'column',
            zIndex: 1,
            name: text2,
            color: '#4E60FE',
            lineWidth: 5,
            yAxis: 1,
            //-3.9, -2.2, -3.5, -3.8, -3.5, -3.9, -1, -5.9, -5.9, -5.9, -5.9, -2.4
            data: json2
    };
    if( TMS.ios ){
        data1.lineWidth = 2;
        data2.lineWidth = 2;
    }
    seriesData.push(data1);
    seriesData.push(data2);
    var em = parseInt($("body").css("font-size"));
    var chartObj = {
        chart: {
           /* type:'line',*/
            spacing:[0,10, 30, 0]
        },
        rangeSelector :{
            enabled: false,
            inputDateFormat: '%Y-%m-%d',
            inputEnabled:false,
            selected:0
            // buttonPosition:{
                // x:0,
                // y:-100
            // },
            // buttons: []
        },
        scrollbar:{
            enabled: true,
            step: .2
        },
        navigator:{
            enabled: true,
            handles: {}
        },
        credits:{ 
            text:'',
            href:'javascript:;'
        },
        xAxis: {
            type: 'datetime',
            dateTimeLabelFormats: {
                day: '%m-%d'
            },
            crosshair: false,
            labels:{style:{fontSize: .6*em,color: '#C0C0C0'}},
            tickLength: 0
        },
        yAxis: [
            {
                //tickInterval: 0.4,
                opposite: false,
                //min: 1.6,
                //max: 2.8,
                //tickInterval: .5,
                labels:{style:{fontSize: .6*em,color: '#C0C0C0'}},
                //tickPositions: [1.6,2,2.4,2.8],
                title: {
                    text: '收益率(%)',
                    style: {fontSize: .6*em,color: '#C0C0C0'},
                    x: 0.5*em
                },
                plotLines: [{
                                 value: 0,
                                 width: 1,
                                 color: '#C0C0C0'
                           }]
            },
            {
                //tickInterval: 20,
                opposite: true,
                //min: 0,
                //max: 60,
                //tickInterval: 2,
                labels:{style:{fontSize: .6*em,color: '#C0C0C0'}},
                //tickPositions: [0,20,40,60],
                title: {
                    text: '量(亿)',
                    style: {fontSize: .6*em,color: '#C0C0C0'},
                    x: -0.5*em
                },
                plotLines: [{
                                 value: 0,
                                 width: 1,
                                 color: '#C0C0C0'
                           }]
            }
        ],
        plotOptions: {
            spline: {
                states: {
                    hover: {
                        lineWidth: 2
                    }
                },
            },
            series:{
                pointStart: Date.UTC(firstDay.y, firstDay.m, firstDay.d),
                //pointIntervalUnit: 'day',
                pointInterval: 1 * 24 * 3600 * 1000,// 间隔2天
                marker: {
                    enabled: true,
                    radius: 5,
                    symbol: 'circle'
                }
            }
        },
        dataLabels: {
            enabled: true
        },
        series: seriesData,
        legend: {
            itemStyle: {color: "#000",fontWeight:'normal', fontSize:.6*em},
            itemHoverStyle: {color: "#FD676E"},
            itemHiddenStyle: {color: "#606063"},
            verticalAlign: "top",
            align: "right",
            itemMarginBottom:10,
            symbolPadding:10,
            symbolWidth: 10,
            enabled: true,
            y:0,
            x:0,
            symbolHeight: 10
        },
        tooltip : {
            hideDelay : 500,
            split: false,
            shared: true,
            style: {},
            dateTimeLabelFormats: {},
            formatter:function(){
                var html = "<strong>"+TM.timeStr(this.x,"ymd2")
                +"</strong><br />价格："+this.y.toFixed(2)
                +"<br />成交量："+(this.points[1]?this.points[1].y.toFixed(2):"");
                return html;
            }
        }
    };
    if( TMS.ios){
        chartObj.plotOptions.series.marker.radius = 2;
        chartObj.legend.symbolWidth = 0;
    }else if( TMS.isAndroid ){
        chartObj.plotOptions.series.marker.radius = 0.1 * em;
        chartObj.chart.spacing = [ 10,10, 30, 0];
        chartObj.tooltip.style.fontSize = .75 * em + "px";
        chartObj.tooltip.headerFormat = '<small>{point.key}</small><br/>';
        chartObj.tooltip.dateTimeLabelFormats.hour = '%Y-%m-%d %H:%M';
        chartObj.scrollbar.height = 1.25 * em;
        chartObj.scrollbar.borderWidth = 2.5 * em;
        chartObj.navigator.height = 2.5 * em;
        chartObj.navigator.handles.height = 1.5 * em;
        chartObj.navigator.handles.width = 1 * em;
        chartObj.navigator.handles.fontSize = .75 * em;
        //chartObj.yAxis[0].title = {x:1.5*em};
        chartObj.legend.y = 10;
    }
    try{
        var chart = Highcharts.stockChart('highcharts', chartObj);
    }catch(e){
    }
}
/* 折线图  */
var setHighStock3 = function(js1,firstDay){
    var json1111 = [
        ['2018/6/20',2.45],
        ['2018/6/21',2.5],
        ['2018/6/22',2.6],
        ['2018/6/23',2.5],
        ['2018/6/24',2.68],
        ['2018/6/25',2.72],
        ['2018/6/26',2],
        ['2018/6/27',2.3],
        ['2018/6/28',2.35],
        ['2018/6/29',2.5],
        ['2018/6/30',2.35],
        ['2018/6/31',2.34]
    ].map(function (d) {
        return [new Date(d[0]).getTime(), d[1]];
    });
    var json1 = [];
    if(js1 && js1.length > 0)json1 = js1;
    var seriesData = [];
    var data1 = {
            name: 'BID',
            color: '#FD676E',
            lineWidth: 5,
            //5, 4.7, 4.9, 4.5, 4.6, 3.6, 4.2, 4.1, 2.9, 3.2, 3, 3.9
            data: json1
    };
    if( TMS.ios ){
        data1.lineWidth = 2;
    }
    seriesData.push(data1);
    var em = parseInt($("body").css("font-size"));
    var chartObj = {
        chart: {
           /* type:'line',*/
            spacing:[0,10, 30, 0]
        },
        rangeSelector :{
            enabled: false,
            inputDateFormat: '%Y-%m-%d',
            inputEnabled:false,
            selected:0
        },
        scrollbar:{
            enabled: true
        },
        navigator:{
            enabled: true,
            handles: {}
        },
        credits:{ 
            text:'',
            href:'javascript:;'
        },
        xAxis: {
            type: 'datetime',
            dateTimeLabelFormats: {
                day: '%m-%d'
            },
            crosshair: false,
            labels:{style:{fontSize: .6*em,color: '#C0C0C0'}},
            tickLength: 0
        },
        yAxis: {
            //tickInterval: 0.25,
            opposite: false,
            //min: 1.5,
            //max: 2.75,
            //tickInterval: .5,
            labels:{style:{fontSize: .6*em,color: '#C0C0C0'}},
            //tickPositions: [1.5,1.75,2,2.25,2.5,2.75,3],
            title: {
                text: '收益率(%)',
                style: {fontSize: .6*em,color: '#C0C0C0'},
                x: 0.5*em
            },
            plotLines: [{
                                 value: 0,
                                 width: 1,
                                 color: '#C0C0C0'
                           }]
        },
        plotOptions: {
            spline: {
                states: {
                    hover: {
                        lineWidth: 2
                    }
                },
            },
            series:{
                pointStart: Date.UTC(firstDay.y, firstDay.m, firstDay.d),
                //pointIntervalUnit: 'day',
                pointInterval: 1 * 24 * 3600 * 1000,// 间隔2天
                marker: {
                    enabled: true,
                    radius: 5,
                    symbol: 'circle'
                }
            }
        },
        dataLabels: {
            enabled: true
        },
        series: seriesData,
        // legend: {
            // itemStyle: {color: "#000",fontWeight:'normal', fontSize:.6*em},
            // itemHoverStyle: {color: "#FD676E"},
            // itemHiddenStyle: {color: "#606063"},
            // verticalAlign: "top",
            // align: "right",
            // itemMarginBottom:10,
            // symbolPadding:10,
            // symbolWidth: 10,
            // enabled: true,
            // y:0,
            // x:0
        // },
        legend:{
            
        },
        tooltip : {
            hideDelay : 500,
            split: false,
            shared: true,
            style: {},
            dateTimeLabelFormats: {}
        }
    };
    if( TMS.ios ){
        chartObj.plotOptions.series.marker.radius = 2;
        chartObj.legend.symbolWidth = 0;
    }else if( TMS.isAndroid ){
        chartObj.plotOptions.series.marker.radius = 0.1 * em;
        chartObj.chart.spacing = [ 10,10, 30, 0];
        chartObj.tooltip.style.fontSize = .75 * em + "px";
        chartObj.tooltip.headerFormat = '<small>{point.key}</small><br/>';
        chartObj.tooltip.dateTimeLabelFormats.hour = '%Y-%m-%d %H:%M';
        chartObj.scrollbar.height = 1.25 * em;
        chartObj.scrollbar.borderWidth = 2.5 * em;
        chartObj.navigator.height = 2.5 * em;
        chartObj.navigator.handles.height = 1.5 * em;
        chartObj.navigator.handles.width = 1 * em;
        chartObj.navigator.handles.fontSize = .75 * em;
    }
    var chart = Highcharts.stockChart('highcharts', chartObj);
}
/*  折线图 * 3+柱状图  */
var setHighStock4 = function(js1,js2,js3,js4,firstDay){
    if( !firstDay){
        firstDay = {y:2018,m:11,d:29};
    }
    var json1 = [];
    var json2 = [];
    var json3 = [];
    var json4 = [];
    if(js1 && js1.length > 0)json1 = js1;
    if(js2 && js2.length > 0)json2 = js2;
    if(js3 && js3.length > 0)json3 = js3;
    if(js4 && js4.length > 0)json4 = js4;
    var seriesData = [];
    var data1 = {
            type: 'spline',
            zIndex: 2,
            name: 'BID',
            color: '#FD676E',
            lineWidth: 5,
            //5, 4.7, 4.9, 4.5, 4.6, 3.6, 4.2, 4.1, 2.9, 3.2, 3, 3.9
            data: json2,
            yAxis: 0
    };
    var data2 = {
            type: 'spline',
            zIndex: 2,
            name: 'Ofr',
            color: '#ACDD7F',
            lineWidth: 5,
            //5, 4.7, 4.9, 4.5, 4.6, 3.6, 4.2, 4.1, 2.9, 3.2, 3, 3.9
            data: json1,
            yAxis: 0
    };
    var data3 = {
            type: 'spline',
            zIndex: 2,
            name: '成交',
            color: '#FF9933',
            lineWidth: 5,
            //5, 4.7, 4.9, 4.5, 4.6, 3.6, 4.2, 4.1, 2.9, 3.2, 3, 3.9
            data: json3,
            yAxis: 0
    };
    var data4 = {
            type: 'column',
            zIndex: 1,
            name: '成交量',
            color: '#4E60FE',
            lineWidth: 5,
            yAxis: 1,
            //-3.9, -2.2, -3.5, -3.8, -3.5, -3.9, -1, -5.9, -5.9, -5.9, -5.9, -2.4
            data: json4
    };
    if( TMS.ios ){
        data1.lineWidth = 2;
        data2.lineWidth = 2;
        data3.lineWidth = 2;
        data4.lineWidth = 2;
    }
    seriesData.push(data1);
    seriesData.push(data2);
    seriesData.push(data3);
    seriesData.push(data4);
    var em = parseInt($("body").css("font-size"));
    var chartObj = {
        chart: {
           /* type:'line',*/
            spacing:[0,10, 30, 0]
        },
        rangeSelector :{
            enabled: false,
            inputDateFormat: '%Y-%m-%d',
            inputEnabled:false,
            selected:0
        },
        scrollbar:{
            enabled: true
        },
        navigator:{
            enabled: true,
            handles: {}
        },
        credits:{ 
            text:'',
            href:'javascript:;'
        },
        xAxis: {
            type: 'datetime',
            dateTimeLabelFormats: {
                day: '%m-%d'
            },
            crosshair: false,
            labels:{style:{fontSize: .6*em,color: '#C0C0C0'}},
            tickLength: 0
        },
        yAxis: [
            {
                //tickInterval: 0.4,
                opposite: false,
                //min: 1.6,
                //max: 2.8,
                //tickInterval: .5,
                labels:{style:{fontSize: .6*em,color: '#C0C0C0'}},
                //tickPositions: [1.6,2,2.4,2.8],
                title: {
                    text: '收益率(%)',
                    style: {fontSize: .6*em,color: '#C0C0C0'},
                    x: 0.5*em
                },
                plotLines: [{
                                 value: 0,
                                 width: 1,
                                 color: '#C0C0C0'
                           }]
            },
            {
                //tickInterval: 20,
                opposite: true,
                //min: 0,
                //max: 60,
                //tickInterval: 2,
                labels:{style:{fontSize: .6*em,color: '#C0C0C0'}},
                //tickPositions: [0,20,40,60],
                title: {
                    text: '量(亿)',
                    style: {fontSize: .6*em,color: '#C0C0C0'},
                    x: -0.5*em
                },
                plotLines: [{
                                 value: 0,
                                 width: 1,
                                 color: '#C0C0C0'
                           }]
            }
        ],
        plotOptions: {
            spline: {
                states: {
                    hover: {
                        lineWidth: 2
                    }
                },
            },
            series:{
                pointStart: Date.UTC(firstDay.y, firstDay.m, firstDay.d),
                //pointIntervalUnit: 'day',
                pointInterval: 1 * 24 * 3600 * 1000,// 间隔2天
                marker: {
                    enabled: true,
                    radius: 5,
                    symbol: 'circle'
                }
            }
        },
        dataLabels: {
            enabled: true
        },
        series: seriesData,
        legend: {
            itemStyle: {color: "#000",fontWeight:'normal', fontSize:.6*em},
            itemHoverStyle: {color: "#FD676E"},
            itemHiddenStyle: {color: "#606063"},
            verticalAlign: "top",
            align: "right",
            itemMarginBottom:10,
            symbolPadding:10,
            symbolWidth: 10,
            enabled: true,
            y:10,
            x:0,
            symbolHeight: 10
        },
        tooltip : {
            hideDelay : 500,
            split: false,
            shared: true,
            style: {},
            dateTimeLabelFormats: {}
        }
    };
    if( TMS.ios){
        chartObj.plotOptions.series.marker.radius = 2;
        chartObj.legend.symbolWidth = 0;
    }else if( TMS.isAndroid ){
        chartObj.plotOptions.series.marker.radius = 0.1 * em;
        chartObj.chart.spacing = [ 10,10, 30, 0];
        chartObj.tooltip.style.fontSize = .75 * em + "px";
        chartObj.tooltip.headerFormat = '<small>{point.key}</small><br/>';
        chartObj.tooltip.dateTimeLabelFormats.hour = '%Y-%m-%d %H:%M';
        chartObj.scrollbar.height = 1.25 * em;
        chartObj.scrollbar.borderWidth = 2.5 * em;
        chartObj.navigator.height = 2.5 * em;
        chartObj.navigator.handles.height = 1.5 * em;
        chartObj.navigator.handles.width = 1 * em;
        chartObj.navigator.handles.fontSize = .75 * em;
    }
    try{
        var chart = Highcharts.stockChart('highcharts', chartObj);
    }catch(e){
    }
}
/*  折线图 * 3+柱状图  +上下轨最大值最小值 */
var setHighStock5 = function(js1,js2,js3,js4,js5,firstDay){
    if( !firstDay){
        firstDay = {y:2018,m:11,d:29};
    }
    var json1 = [];
    var json2 = [];
    var json3 = [];
    var json4 = [];
    var json5 = [];
    if(js1 && js1.length > 0)json1 = js1;
    if(js2 && js2.length > 0)json2 = js2;
    if(js3 && js3.length > 0)json3 = js3;
    if(js4 && js4.length > 0)json4 = js4;
    if(js5 && js5.length > 0)json5 = js5;
    var seriesData = [];
    var data1 = {
            type: 'spline',
            name: 'BID',
            color: '#FD676E',
            lineWidth: 5,
            //5, 4.7, 4.9, 4.5, 4.6, 3.6, 4.2, 4.1, 2.9, 3.2, 3, 3.9
            data: json2,
            yAxis: 0,
            zIndex: 2
    };
    var data2 = {
            type: 'spline',
            name: 'Ofr',
            color: '#ACDD7F',
            lineWidth: 5,
            //5, 4.7, 4.9, 4.5, 4.6, 3.6, 4.2, 4.1, 2.9, 3.2, 3, 3.9
            data: json1,
            yAxis: 0,
            zIndex: 2
    };
    var data3 = {
            type: 'column',
            name: '成交量',
            color: '#4E60FE',
            lineWidth: 5,
            data: json3,
            yAxis: 1,
            zIndex: 0
    };
    var data4 = {
            type: 'spline',
            name: '成交',
            color: '#FF9933',
            lineWidth: 5,
            yAxis: 0,
            data: json4,
            zIndex: 2
    };
    var data5 = {
            type: 'arearange',
            name: '成交范围',
            color: '#33cc99',
            lineWidth: 0,
            linkedTo:':previous',
            data: json5,
            //color: Highcharts.getOptions().colors[2],
            fillOpacity: 0.3,
            zIndex: 1,
            yAxis: 0,
            marker: {
                enabled: false
            }
    };
    if( TMS.ios ){
        data1.lineWidth = 2;
        data2.lineWidth = 2;
        data3.lineWidth = 2;
        data4.lineWidth = 2;
    }
    seriesData.push(data1);
    seriesData.push(data2);
    seriesData.push(data3);
    seriesData.push(data4);
    seriesData.push(data5);
    var em = parseInt($("body").css("font-size"));
    var chartObj = {
        chart: {
           /* type:'line',*/
            spacing:[0,10, 30, 0]
        },
        rangeSelector :{
            enabled: false,
            inputDateFormat: '%Y-%m-%d',
            inputEnabled:false,
            selected:0
        },
        scrollbar:{
            enabled: true
        },
        navigator:{
            enabled: true,
            handles: {}
        },
        credits:{ 
            text:'',
            href:'javascript:;'
        },
        xAxis: {
            type: 'datetime',
            dateTimeLabelFormats: {
                day: '%m-%d'
            },
            crosshair: false,
            labels:{style:{fontSize: .6*em,color: '#C0C0C0'}},
            tickLength: 0
        },
        yAxis: [
            {
                //tickInterval: 0.4,
                opposite: false,
                //min: 1.6,
                //max: 2.8,
                //tickInterval: .5,
                labels:{style:{fontSize: .6*em,color: '#C0C0C0'}},
                //tickPositions: [1.6,2,2.4,2.8],
                title: {
                    text: '收益率(%)',
                    style: {fontSize: .6*em,color: '#C0C0C0'},
                    x: 0.5*em
                },
                plotLines: [{
                                 value: 0,
                                 width: 1,
                                 color: '#C0C0C0'
                           }]
            },
            {
                //tickInterval: 20,
                opposite: true,
                //min: 0,
                //max: 60,
                //tickInterval: 2,
                labels:{style:{fontSize: .6*em,color: '#C0C0C0'}},
                //tickPositions: [0,20,40,60],
                title: {
                    text: '量(亿)',
                    style: {fontSize: .6*em,color: '#C0C0C0'},
                    x: -0.5*em
                },
                plotLines: [{
                                 value: 0,
                                 width: 1,
                                 color: '#C0C0C0'
                           }]
            }
        ],
        plotOptions: {
            spline: {
                states: {
                    hover: {
                        lineWidth: 2
                    }
                },
            },
            series:{
                pointStart: Date.UTC(firstDay.y, firstDay.m, firstDay.d),
                //pointIntervalUnit: 'day',
                pointInterval: 1 * 24 * 3600 * 1000,// 间隔2天
                marker: {
                    enabled: true,
                    radius: 5,
                    symbol: 'circle'
                }
            }
        },
        dataLabels: {
            enabled: true
        },
        series: seriesData,
        legend: {
            itemStyle: {color: "#000",fontWeight:'normal', fontSize:.6*em},
            itemHoverStyle: {color: "#FD676E"},
            itemHiddenStyle: {color: "#606063"},
            verticalAlign: "top",
            align: "right",
            itemMarginBottom:10,
            symbolPadding:10,
            symbolWidth: 10,
            enabled: true,
            y:10,
            x:0,
            symbolHeight: 10
        },
        tooltip : {
            hideDelay : 500,
            split: false,
            shared: true,
            style: {},
            dateTimeLabelFormats: {}
        }
    };
    if( TMS.ios){
        chartObj.plotOptions.series.marker.radius = 2;
        chartObj.legend.symbolWidth = 0;
    }else if( TMS.isAndroid ){
        chartObj.plotOptions.series.marker.radius = 0.1 * em;
        chartObj.chart.spacing = [ 10,10, 30, 0];
        chartObj.tooltip.style.fontSize = .75 * em + "px";
        chartObj.tooltip.headerFormat = '<small>{point.key}</small><br/>';
        chartObj.tooltip.dateTimeLabelFormats.hour = '%Y-%m-%d %H:%M';
        chartObj.scrollbar.height = 1.25 * em;
        chartObj.scrollbar.borderWidth = 2.5 * em;
        chartObj.navigator.height = 2.5 * em;
        chartObj.navigator.handles.height = 1.5 * em;
        chartObj.navigator.handles.width = 1 * em;
        chartObj.navigator.handles.fontSize = .75 * em;
    }
    try{
        var chart = Highcharts.stockChart('highcharts', chartObj);
    }catch(e){
    }
}